--[[
Name: LibBabble-Boss-3.0
Revision: $Rev: 363 $
Maintainers: ckknight, nevcairiel, Ackis
Website: http://www.wowace.com/projects/libbabble-boss-3-0/
Dependencies: None
License: MIT
]]

local MAJOR_VERSION = "LibBabble-Boss-3.0"
local MINOR_VERSION = 90000 + tonumber(("$Rev: 363 $"):match("%d+"))

if not LibStub then error(MAJOR_VERSION .. " requires LibStub.") end
local lib = LibStub("LibBabble-3.0"):New(MAJOR_VERSION, MINOR_VERSION)
if not lib then return end

local GAME_LOCALE = GetLocale()

lib:SetBaseTranslations {
	["\"Captain\" Cookie"] = "\"Captain\" Cookie",
	Acidmaw = "Acidmaw",
	["Admiral Ripsnarl"] = "Admiral Ripsnarl",
	Aeonus = "Aeonus",
	["Aerial Command Unit"] = "Aerial Command Unit",
	["Agathelos the Raging"] = "Agathelos the Raging",
	["Aggem Thorncurse"] = "Aggem Thorncurse",
	Ahune = "Ahune",
	["Akil'zon"] = "Akil'zon",
	["Aku'mai"] = "Aku'mai",
	["Al'Akir"] = "Al'Akir",
	["Al'ar"] = "Al'ar",
	["Algalon the Observer"] = "Algalon the Observer",
	Altairus = "Altairus",
	Altarius = "Altarius",
	Alysrazor = "Alysrazor",
	["Alzzin the Wildshaper"] = "Alzzin the Wildshaper",
	Amanitar = "Amanitar",
	["Ambassador Flamelash"] = "Ambassador Flamelash",
	["Ambassador Hellmaw"] = "Ambassador Hellmaw",
	Ammunae = "Ammunae",
	["Amnennar the Coldbringer"] = "Amnennar the Coldbringer",
	["Ancient Stone Keeper"] = "Ancient Stone Keeper",
	Anetheron = "Anetheron",
	["Anger'rel"] = "Anger'rel",
	Anomalus = "Anomalus",
	Anraphet = "Anraphet",
	Anshal = "Anshal",
	["Antu'sul"] = "Antu'sul",
	["Anub'Rekhan"] = "Anub'Rekhan",
	["Anub'arak"] = "Anub'arak",
	["Anub'shiah"] = "Anub'shiah",
	["Anubisath Defender"] = "Anubisath Defender",
	["Anubisath Guardian"] = "Anubisath Guardian",
	Anzu = "Anzu",
	["Arcane Watchman"] = "Arcane Watchman",
	["Arcanist Doan"] = "Arcanist Doan",
	Arcanotron = "Arcanotron",
	Archaedas = "Archaedas",
	["Archavon the Stone Watcher"] = "Archavon the Stone Watcher",
	["Archbishop Benedictus"] = "Archbishop Benedictus",
	Archimonde = "Archimonde",
	["Archivist Galford"] = "Archivist Galford",
	["Archmage Arugal"] = "Archmage Arugal",
	Arcurion = "Arcurion",
	Argaloth = "Argaloth",
	["Argent Confessor Paletress"] = "Argent Confessor Paletress",
	Arion = "Arion",
	["Arugal's Voidwalker"] = "Arugal's Voidwalker",
	Asaad = "Asaad",
	["Ascendant Council"] = "Ascendant Council",
	["Ascendant Lord Obsidius"] = "Ascendant Lord Obsidius",
	["Asim al Akir"] = "Asim al Akir",
	["Asira Dawnslayer"] = "Asira Dawnslayer",
	["Assault Bot"] = "Assault Bot",
	["Assembly of Iron"] = "Assembly of Iron",
	["Atal'alarion"] = "Atal'alarion",
	Atramedes = "Atramedes",
	["Attumen the Huntsman"] = "Attumen the Huntsman",
	Auriaya = "Auriaya",
	Avalanchion = "Avalanchion",
	["Avatar of Hakkar"] = "Avatar of Hakkar",
	["Ayamiss the Hunter"] = "Ayamiss the Hunter",
	Azgalor = "Azgalor",
	["Azshir the Sleepless"] = "Azshir the Sleepless",
	Azuregos = "Azuregos",
	["Bael'Gar"] = "Bael'Gar",
	Baelog = "Baelog",
	Baleroc = "Baleroc",
	Balnazzar = "Balnazzar",
	["Baltharus the Warborn"] = "Baltharus the Warborn",
	["Bannok Grimaxe"] = "Bannok Grimaxe",
	["Baron Aquanis"] = "Baron Aquanis",
	["Baron Ashbury"] = "Baron Ashbury",
	["Baron Charr"] = "Baron Charr",
	["Baron Geddon"] = "Baron Geddon",
	["Baron Kazum"] = "Baron Kazum",
	["Baron Rivendare"] = "Baron Rivendare",
	["Baron Silverlaine"] = "Baron Silverlaine",
	["Baroness Anastari"] = "Baroness Anastari",
	["Battleguard Sartura"] = "Battleguard Sartura",
	["Bazil Thredd"] = "Bazil Thredd",
	Bazzalan = "Bazzalan",
	Beauty = "Beauty",
	["Beth'tilac"] = "Beth'tilac",
	["Black Guard Swordsmith"] = "Black Guard Swordsmith",
	["Blackheart the Inciter"] = "Blackheart the Inciter",
	["Blind Hunter"] = "Blind Hunter",
	["Blindeye the Seer"] = "Blindeye the Seer",
	["Blood Council"] = "Blood Council",
	["Blood Guard Porung"] = "Blood Guard Porung",
	["Blood Prince Council"] = "Blood Prince Council",
	["Blood Princes"] = "Blood Princes",
	["Blood Steward of Kirtonos"] = "Blood Steward of Kirtonos",
	["Blood-Queen Lana'thel"] = "Blood-Queen Lana'thel",
	["Bloodlord Mandokir"] = "Bloodlord Mandokir",
	["Bloodmage Thalnos"] = "Bloodmage Thalnos",
	Boahn = "Boahn",
	["Bomb Bot"] = "Bomb Bot",
	["Brain of Yogg-Saron"] = "Brain of Yogg-Saron",
	["Brainwashed Noble"] = "Brainwashed Noble",
	Broggok = "Broggok",
	Brokentoe = "Brokentoe",
	Bronjahm = "Bronjahm",
	["Broodlord Lashlayer"] = "Broodlord Lashlayer",
	["Bruegal Ironknuckle"] = "Bruegal Ironknuckle",
	Brutallus = "Brutallus",
	["Burning Felguard"] = "Burning Felguard",
	["Buru the Gorger"] = "Buru the Gorger",
	["C'Thun"] = "C'Thun",
	["Cache of the Firelord"] = "Cache of the Firelord",
	["Cache of the Legion"] = "Cache of the Legion",
	["Cannon Master Willey"] = "Cannon Master Willey",
	["Captain Greenskin"] = "Captain Greenskin",
	["Captain Kromcrush"] = "Captain Kromcrush",
	["Captain Skarloc"] = "Captain Skarloc",
	["Captain Varo'then"] = "Captain Varo'then",
	["Celebras the Cursed"] = "Celebras the Cursed",
	["Charlga Razorflank"] = "Charlga Razorflank",
	["Chess Event"] = "Chess Event",
	["Chest of The Seven"] = "Chest of The Seven",
	["Chief Ukorz Sandscalp"] = "Chief Ukorz Sandscalp",
	Chimaeron = "Chimaeron",
	["Cho'Rush the Observer"] = "Cho'Rush the Observer",
	["Cho'gall"] = "Cho'gall",
	Chromaggus = "Chromaggus",
	["Chrono Lord Deja"] = "Chrono Lord Deja",
	["Chrono-Lord Epoch"] = "Chrono-Lord Epoch",
	Claw = "Claw",
	["Coilfang Elite"] = "Coilfang Elite",
	["Coilfang Strider"] = "Coilfang Strider",
	["Commander Kolurg"] = "Commander Kolurg",
	["Commander Malor"] = "Commander Malor",
	["Commander Sarannis"] = "Commander Sarannis",
	["Commander Springvale"] = "Commander Springvale",
	["Commander Stoutbeard"] = "Commander Stoutbeard",
	["Commander Ulthok"] = "Commander Ulthok",
	["Conclave of Wind"] = "Conclave of Wind",
	["Constructor & Controller"] = "Constructor & Controller",
	Cookie = "Cookie",
	Corborus = "Corborus",
	["Coren Direbrew"] = "Coren Direbrew",
	["Corla, Herald of Twilight"] = "Corla, Herald of Twilight",
	["Cosmic Infuser"] = "Cosmic Infuser",
	["Crimson Hammersmith"] = "Crimson Hammersmith",
	["Crowd Pummeler 9-60"] = "Crowd Pummeler 9-60",
	["Crystal Fang"] = "Crystal Fang",
	Cyanigosa = "Cyanigosa",
	Daakara = "Daakara",
	["Dalliah the Doomsayer"] = "Dalliah the Doomsayer",
	["Dalronn the Controller"] = "Dalronn the Controller",
	["Dark Coffer"] = "Dark Coffer",
	["Dark Iron Ambassador"] = "Dark Iron Ambassador",
	["Darkmaster Gandling"] = "Darkmaster Gandling",
	["Darkweaver Syth"] = "Darkweaver Syth",
	["Death Knight Darkreaver"] = "Death Knight Darkreaver",
	["Death Knight Understudy"] = "Death Knight Understudy",
	["Death Speaker Jargba"] = "Death Speaker Jargba",
	["Deathbound Ward"] = "Deathbound Ward",
	["Deathbringer Saurfang"] = "Deathbringer Saurfang",
	["Deathspeaker High Priest"] = "Deathspeaker High Priest",
	["Deathstalker Visceri"] = "Deathstalker Visceri",
	["Deathsworn Captain"] = "Deathsworn Captain",
	Devastation = "Devastation",
	["Deviate Faerie Dragon"] = "Deviate Faerie Dragon",
	["Devourer of Souls"] = "Devourer of Souls",
	["Dextren Ward"] = "Dextren Ward",
	["Digmaster Shovelphlange"] = "Digmaster Shovelphlange",
	["Doctor Theolen Krastinov"] = "Doctor Theolen Krastinov",
	["Doom Lord Kazzak"] = "Doom Lord Kazzak",
	["Doom'rel"] = "Doom'rel",
	Doomwalker = "Doomwalker",
	["Dope'rel"] = "Dope'rel",
	Dorothee = "Dorothee",
	["Drahga Shadowburner"] = "Drahga Shadowburner",
	["Drahga Shodowburner"] = "Drahga Shodowburner",
	["Drakkari Colossus"] = "Drakkari Colossus",
	["Drakos the Interrogator"] = "Drakos the Interrogator",
	Dreadscale = "Dreadscale",
	Dreamscythe = "Dreamscythe",
	["Dust Covered Chest"] = "Dust Covered Chest",
	Dustwraith = "Dustwraith",
	["Eadric the Pure"] = "Eadric the Pure",
	["Earthcaller Halmgar"] = "Earthcaller Halmgar",
	["Earthrager Ptah"] = "Earthrager Ptah",
	Ebonroc = "Ebonroc",
	["Echo of Baine"] = "Echo of Baine",
	["Echo of Jaina"] = "Echo of Jaina",
	["Echo of Sylvanas"] = "Echo of Sylvanas",
	["Echo of Tyrande"] = "Echo of Tyrande",
	["Eck the Ferocious"] = "Eck the Ferocious",
	["Edwin VanCleef"] = "Edwin VanCleef",
	["Elder Brightleaf"] = "Elder Brightleaf",
	["Elder Ironbranch"] = "Elder Ironbranch",
	["Elder Nadox"] = "Elder Nadox",
	["Elder Stonebark"] = "Elder Stonebark",
	["Electrocutioner 6000"] = "Electrocutioner 6000",
	Electron = "Electron",
	["Elementium Monstrosity"] = "Elementium Monstrosity",
	["Emalon the Storm Watcher"] = "Emalon the Storm Watcher",
	Emeriss = "Emeriss",
	["Emperor Dagran Thaurissan"] = "Emperor Dagran Thaurissan",
	["Emperor Vek'lor"] = "Emperor Vek'lor",
	["Emperor Vek'nilash"] = "Emperor Vek'nilash",
	Entropius = "Entropius",
	["Eonar's Gift"] = "Eonar's Gift",
	["Epoch Hunter"] = "Epoch Hunter",
	Erekem = "Erekem",
	["Eressea Dawnsinger"] = "Eressea Dawnsinger",
	["Eric \"The Swift\""] = "Eric \"The Swift\"",
	Erudax = "Erudax",
	["Erunak Stonespeaker"] = "Erunak Stonespeaker",
	["Essence of Anger"] = "Essence of Anger",
	["Essence of Desire"] = "Essence of Desire",
	["Essence of Suffering"] = "Essence of Suffering",
	Eviscerator = "Eviscerator",
	["Exarch Maladaar"] = "Exarch Maladaar",
	["Expedition Commander"] = "Expedition Commander",
	["Eydis Darkbane"] = "Eydis Darkbane",
	["Eye of C'Thun"] = "Eye of C'Thun",
	["Faction Champions"] = "Faction Champions",
	["Fallen Champion"] = "Fallen Champion",
	Falric = "Falric",
	["Falric and Marwyn"] = "Falric and Marwyn",
	["Fankriss the Unyielding"] = "Fankriss the Unyielding",
	["Fathom-Lord Karathress"] = "Fathom-Lord Karathress",
	Felmyst = "Felmyst",
	Feludius = "Feludius",
	["Fenrus the Devourer"] = "Fenrus the Devourer",
	["Feral Defender"] = "Feral Defender",
	Festergut = "Festergut",
	Feugen = "Feugen",
	["Fineous Darkvire"] = "Fineous Darkvire",
	Firemaw = "Firemaw",
	["Fjola Lightbane"] = "Fjola Lightbane",
	["Flame Leviathan"] = "Flame Leviathan",
	Flamegor = "Flamegor",
	["Foe Reaper 5000"] = "Foe Reaper 5000",
	["Foreman Thistlenettle"] = "Foreman Thistlenettle",
	["Forgemaster Garfrost"] = "Forgemaster Garfrost",
	["Forgemaster Throngus"] = "Forgemaster Throngus",
	["Four Horsemen Chest"] = "Four Horsemen Chest",
	["Fras Siabi"] = "Fras Siabi",
	Freya = "Freya",
	["Gahz'ranka"] = "Gahz'ranka",
	["Gahz'rilla"] = "Gahz'rilla",
	["Gal'darah"] = "Gal'darah",
	["Galgann Firehammer"] = "Galgann Firehammer",
	Garr = "Garr",
	["Garrosh Hellscream"] = "Garrosh Hellscream",
	Gasher = "Gasher",
	["Gatewatcher Gyro-Kill"] = "Gatewatcher Gyro-Kill",
	["Gatewatcher Iron-Hand"] = "Gatewatcher Iron-Hand",
	["Gathios the Shatterer"] = "Gathios the Shatterer",
	Gehennas = "Gehennas",
	Gelihast = "Gelihast",
	Gelk = "Gelk",
	["General Angerforge"] = "General Angerforge",
	["General Bjarngrim"] = "General Bjarngrim",
	["General Drakkisath"] = "General Drakkisath",
	["General Husam"] = "General Husam",
	["General Rajaxx"] = "General Rajaxx",
	["General Umbriss"] = "General Umbriss",
	["General Vezax"] = "General Vezax",
	["General Zarithrian"] = "General Zarithrian",
	["Ghamoo-ra"] = "Ghamoo-ra",
	["Ghaz'an"] = "Ghaz'an",
	["Ghok Bashguud"] = "Ghok Bashguud",
	Gilnid = "Gilnid",
	["Gizrul the Slavener"] = "Gizrul the Slavener",
	["Gloom'rel"] = "Gloom'rel",
	Glubtok = "Glubtok",
	Gluth = "Gluth",
	Glutton = "Glutton",
	["Golem Lord Argelmach"] = "Golem Lord Argelmach",
	["Golemagg the Incinerator"] = "Golemagg the Incinerator",
	["Goraluk Anvilcrack"] = "Goraluk Anvilcrack",
	["Gormok the Impaler"] = "Gormok the Impaler",
	["Gorosh the Dervish"] = "Gorosh the Dervish",
	["Gortok Palehoof"] = "Gortok Palehoof",
	["Gothik the Harvester"] = "Gothik the Harvester",
	["Grand Astromancer Capernian"] = "Grand Astromancer Capernian",
	["Grand Champions"] = "Grand Champions",
	["Grand Crusader Dathrohan"] = "Grand Crusader Dathrohan",
	["Grand Magus Telestra"] = "Grand Magus Telestra",
	["Grand Vizier Ertan"] = "Grand Vizier Ertan",
	["Grand Warlock Alythess"] = "Grand Warlock Alythess",
	["Grand Warlock Nethekurse"] = "Grand Warlock Nethekurse",
	["Grand Widow Faerlina"] = "Grand Widow Faerlina",
	["Grandmaster Vorpil"] = "Grandmaster Vorpil",
	Grandmother = "Grandmother",
	["Grethok the Controller"] = "Grethok the Controller",
	["Gri'lek"] = "Gri'lek",
	Grimlok = "Grimlok",
	Grizzle = "Grizzle",
	Grobbulus = "Grobbulus",
	Grubbis = "Grubbis",
	["Gruul the Dragonkiller"] = "Gruul the Dragonkiller",
	["Guard Fengus"] = "Guard Fengus",
	["Guard Mol'dar"] = "Guard Mol'dar",
	["Guard Slip'kik"] = "Guard Slip'kik",
	["Guardian of Yogg-Saron"] = "Guardian of Yogg-Saron",
	["Gurtogg Bloodboil"] = "Gurtogg Bloodboil",
	Gyth = "Gyth",
	Hadronox = "Hadronox",
	["Hagara the Stormbinder"] = "Hagara the Stormbinder",
	Hakkar = "Hakkar",
	Halazzi = "Halazzi",
	["Halfus Wyrmbreaker"] = "Halfus Wyrmbreaker",
	Halion = "Halion",
	Halycon = "Halycon",
	Hamhock = "Hamhock",
	["Harbinger Skyriss"] = "Harbinger Skyriss",
	["Hate'rel"] = "Hate'rel",
	["Hazza'rah"] = "Hazza'rah",
	Hazzas = "Hazzas",
	["Headless Horseman"] = "Headless Horseman",
	["Hearthsinger Forresten"] = "Hearthsinger Forresten",
	["Hedrum the Creeper"] = "Hedrum the Creeper",
	["Heigan the Unclean"] = "Heigan the Unclean",
	["Helix Gearbreaker"] = "Helix Gearbreaker",
	["Hellfire Channeler"] = "Hellfire Channeler",
	["Henry Stern"] = "Henry Stern",
	["Herald Volazj"] = "Herald Volazj",
	Herod = "Herod",
	["Hex Lord Malacrass"] = "Hex Lord Malacrass",
	["High Astromancer Solarian"] = "High Astromancer Solarian",
	["High Botanist Freywinn"] = "High Botanist Freywinn",
	["High Inquisitor Fairbanks"] = "High Inquisitor Fairbanks",
	["High Inquisitor Whitemane"] = "High Inquisitor Whitemane",
	["High Interrogator Gerstahn"] = "High Interrogator Gerstahn",
	["High King Maulgar"] = "High King Maulgar",
	["High Marshal Whirlaxis"] = "High Marshal Whirlaxis",
	["High Nethermancer Zerevor"] = "High Nethermancer Zerevor",
	["High Overlord Saurfang"] = "High Overlord Saurfang",
	["High Priest Thekal"] = "High Priest Thekal",
	["High Priest Venoxis"] = "High Priest Venoxis",
	["High Priestess Arlokk"] = "High Priestess Arlokk",
	["High Priestess Azil"] = "High Priestess Azil",
	["High Priestess Jeklik"] = "High Priestess Jeklik",
	["High Priestess Kilnara"] = "High Priestess Kilnara",
	["High Priestess Mar'li"] = "High Priestess Mar'li",
	["High Priestess of Thaurissan"] = "High Priestess of Thaurissan",
	["High Prophet Barim"] = "High Prophet Barim",
	["High Warlord Naj'entus"] = "High Warlord Naj'entus",
	["Highlord Mograine"] = "Highlord Mograine",
	["Highlord Omokk"] = "Highlord Omokk",
	Hodir = "Hodir",
	Hogger = "Hogger",
	["Houndmaster Grebmar"] = "Houndmaster Grebmar",
	["Houndmaster Loksey"] = "Houndmaster Loksey",
	Hukku = "Hukku",
	Hungarfen = "Hungarfen",
	["Hurley Blackbreath"] = "Hurley Blackbreath",
	["Hyakiss the Lurker"] = "Hyakiss the Lurker",
	["Hydromancer Thespia"] = "Hydromancer Thespia",
	["Hydromancer Velratha"] = "Hydromancer Velratha",
	Hydrospawn = "Hydrospawn",
	["Hydross the Unstable"] = "Hydross the Unstable",
	["Ice Sphere"] = "Ice Sphere",
	["Icecrown Gunship Battle"] = "Icecrown Gunship Battle",
	Icehowl = "Icehowl",
	Ichoron = "Ichoron",
	Ick = "Ick",
	Ignacious = "Ignacious",
	["Ignis the Furnace Master"] = "Ignis the Furnace Master",
	["Illidan Stormrage"] = "Illidan Stormrage",
	["Illidari Council"] = "Illidari Council",
	["Illyanna Ravenoak"] = "Illyanna Ravenoak",
	["Immol'thar"] = "Immol'thar",
	["Infinite Corruptor"] = "Infinite Corruptor",
	["Infinity Blades"] = "Infinity Blades",
	["Ingvar the Plunderer"] = "Ingvar the Plunderer",
	["Instructor Galford"] = "Instructor Galford",
	["Instructor Malicia"] = "Instructor Malicia",
	["Instructor Razuvious"] = "Instructor Razuvious",
	["Interrogator Vishas"] = "Interrogator Vishas",
	Ionar = "Ionar",
	Ironaya = "Ironaya",
	Ironspine = "Ironspine",
	Isalien = "Isalien",
	Isiset = "Isiset",
	Jade = "Jade",
	["Jammal'an the Prophet"] = "Jammal'an the Prophet",
	["Jan'alai"] = "Jan'alai",
	["Jandice Barov"] = "Jandice Barov",
	["Jed Runewatcher"] = "Jed Runewatcher",
	["Jedoga Shadowseeker"] = "Jedoga Shadowseeker",
	["Jergosh the Invoker"] = "Jergosh the Invoker",
	["Jin'do the Godbreaker"] = "Jin'do the Godbreaker",
	["Jin'do the Hexxer"] = "Jin'do the Hexxer",
	["Jormungar Behemoth"] = "Jormungar Behemoth",
	Jormungars = "Jormungars",
	Julianne = "Julianne",
	["Junk Bot"] = "Junk Bot",
	["Kael'thas Sunstrider"] = "Kael'thas Sunstrider",
	Kalecgos = "Kalecgos",
	["Kam Deepfury"] = "Kam Deepfury",
	["Karsh Steelbender"] = "Karsh Steelbender",
	["Kaz'rogal"] = "Kaz'rogal",
	["Kazkaz the Unholy"] = "Kazkaz the Unholy",
	["Kel'Thuzad"] = "Kel'Thuzad",
	["Keli'dan the Breaker"] = "Keli'dan the Breaker",
	Keristrasza = "Keristrasza",
	["Kiggler the Crazed"] = "Kiggler the Crazed",
	["Kil'jaeden"] = "Kil'jaeden",
	["Kil'rek"] = "Kil'rek",
	["King Dred"] = "King Dred",
	["King Gordok"] = "King Gordok",
	["King Llane Piece"] = "King Llane Piece",
	["King Ymiron"] = "King Ymiron",
	["Kirtonos the Herald"] = "Kirtonos the Herald",
	["Knot Thimblejack's Cache"] = "Knot Thimblejack's Cache",
	Kolk = "Kolk",
	Kologarn = "Kologarn",
	["Koralon the Flame Watcher"] = "Koralon the Flame Watcher",
	Kormok = "Kormok",
	Kresh = "Kresh",
	Krick = "Krick",
	["Krick and Ick"] = "Krick and Ick",
	["Krik'thir the Gatewatcher"] = "Krik'thir the Gatewatcher",
	["Krosh Firehand"] = "Krosh Firehand",
	Krystallus = "Krystallus",
	Kurinnaxx = "Kurinnaxx",
	["Lady Anacondra"] = "Lady Anacondra",
	["Lady Blaumeux"] = "Lady Blaumeux",
	["Lady Deathwhisper"] = "Lady Deathwhisper",
	["Lady Illucia Barov"] = "Lady Illucia Barov",
	["Lady Malande"] = "Lady Malande",
	["Lady Naz'jar"] = "Lady Naz'jar",
	["Lady Sacrolash"] = "Lady Sacrolash",
	["Lady Sarevess"] = "Lady Sarevess",
	["Lady Vashj"] = "Lady Vashj",
	Laj = "Laj",
	Landslide = "Landslide",
	Lavanthor = "Lavanthor",
	["Left Arm"] = "Left Arm",
	["Leotheras the Blind"] = "Leotheras the Blind",
	Lethon = "Lethon",
	Lethtendris = "Lethtendris",
	["Leviathan Mk II"] = "Leviathan Mk II",
	["Ley-Guardian Eregos"] = "Ley-Guardian Eregos",
	["Lieutenant Drake"] = "Lieutenant Drake",
	["Lieutenant General Andorov"] = "Lieutenant General Andorov",
	Loatheb = "Loatheb",
	Lockmaw = "Lockmaw",
	Loken = "Loken",
	["Lord Alexei Barov"] = "Lord Alexei Barov",
	["Lord Aurius Rivendare"] = "Lord Aurius Rivendare",
	["Lord Cobrahn"] = "Lord Cobrahn",
	["Lord Godfrey"] = "Lord Godfrey",
	["Lord Hel'nurath"] = "Lord Hel'nurath",
	["Lord Incendius"] = "Lord Incendius",
	["Lord Jaraxxus"] = "Lord Jaraxxus",
	["Lord Kazzak"] = "Lord Kazzak",
	["Lord Kri"] = "Lord Kri",
	["Lord Marrowgar"] = "Lord Marrowgar",
	["Lord Overheat"] = "Lord Overheat",
	["Lord Pythas"] = "Lord Pythas",
	["Lord Rhyolith"] = "Lord Rhyolith",
	["Lord Roccor"] = "Lord Roccor",
	["Lord Sanguinar"] = "Lord Sanguinar",
	["Lord Serpentis"] = "Lord Serpentis",
	["Lord Skwol"] = "Lord Skwol",
	["Lord Valthalak"] = "Lord Valthalak",
	["Lord Victor Nefarius"] = "Lord Victor Nefarius",
	["Lord Vyletongue"] = "Lord Vyletongue",
	["Lord Walden"] = "Lord Walden",
	["Lorekeeper Polkelt"] = "Lorekeeper Polkelt",
	["Lorgus Jett"] = "Lorgus Jett",
	Loro = "Loro",
	Lucifron = "Lucifron",
	["M'uru"] = "M'uru",
	["Mad Magglish"] = "Mad Magglish",
	["Madness of Deathwing"] = "Madness of Deathwing",
	Maexxna = "Maexxna",
	["Mage-Lord Urom"] = "Mage-Lord Urom",
	["Magister Kalendris"] = "Magister Kalendris",
	["Magistrate Barthilas"] = "Magistrate Barthilas",
	Magmadar = "Magmadar",
	Magmatron = "Magmatron",
	Magmaw = "Magmaw",
	Magmus = "Magmus",
	Magra = "Magra",
	Magtheridon = "Magtheridon",
	["Maiden of Grief"] = "Maiden of Grief",
	["Maiden of Virtue"] = "Maiden of Virtue",
	["Majordomo Executus"] = "Majordomo Executus",
	["Majordomo Staghelm"] = "Majordomo Staghelm",
	["Mal'Ganis"] = "Mal'Ganis",
	Malacrass = "Malacrass",
	["Maleki the Pallid"] = "Maleki the Pallid",
	Maloriak = "Maloriak",
	Malygos = "Malygos",
	Mannoroth = "Mannoroth",
	Maraudos = "Maraudos",
	["Marduk Blackpool"] = "Marduk Blackpool",
	["Marisa du'Paige"] = "Marisa du'Paige",
	Marwyn = "Marwyn",
	["Master Engineer Telonicus"] = "Master Engineer Telonicus",
	["Maur Grimtotem"] = "Maur Grimtotem",
	Meathook = "Meathook",
	["Mechano-Lord Capacitus"] = "Mechano-Lord Capacitus",
	Medivh = "Medivh",
	["Mekgineer Steamrigger"] = "Mekgineer Steamrigger",
	["Mekgineer Thermaplugg"] = "Mekgineer Thermaplugg",
	["Mennu the Betrayer"] = "Mennu the Betrayer",
	["Meshlok the Harvester"] = "Meshlok the Harvester",
	Midnight = "Midnight",
	Mijan = "Mijan",
	Mimiron = "Mimiron",
	["Mindbender Ghur'sha"] = "Mindbender Ghur'sha",
	["Miner Johnson"] = "Miner Johnson",
	["Mistress of Pain"] = "Mistress of Pain",
	Moam = "Moam",
	Mogor = "Mogor",
	["Mokra the Skullcrusher"] = "Mokra the Skullcrusher",
	Moorabi = "Moorabi",
	["Mor Grayhoof"] = "Mor Grayhoof",
	Moragg = "Moragg",
	Morchok = "Morchok",
	["Mordresh Fire Eye"] = "Mordresh Fire Eye",
	Moroes = "Moroes",
	["Morogrim Tidewalker"] = "Morogrim Tidewalker",
	Morphaz = "Morphaz",
	["Mother Shahraz"] = "Mother Shahraz",
	["Mother Smolderweb"] = "Mother Smolderweb",
	["Mr. Smite"] = "Mr. Smite",
	["Muradin Bronzebeard"] = "Muradin Bronzebeard",
	["Murkblood Twin"] = "Murkblood Twin",
	["Murkblood Twins"] = "Murkblood Twins",
	Murmur = "Murmur",
	Murozond = "Murozond",
	["Murta Grimgut"] = "Murta Grimgut",
	Mushgog = "Mushgog",
	["Mutanus the Devourer"] = "Mutanus the Devourer",
	Nalorakk = "Nalorakk",
	Nazan = "Nazan",
	Nefarian = "Nefarian",
	["Nefarian's End"] = "Nefarian's End",
	["Nekrum Gutchewer"] = "Nekrum Gutchewer",
	["Nerub'enkan"] = "Nerub'enkan",
	["Nethermancer Sepethrea"] = "Nethermancer Sepethrea",
	Netherspite = "Netherspite",
	["Netherstrand Longbow"] = "Netherstrand Longbow",
	["Nexus-Prince Shaffar"] = "Nexus-Prince Shaffar",
	Nezir = "Nezir",
	Nightbane = "Nightbane",
	["Noth the Plaguebringer"] = "Noth the Plaguebringer",
	["Novos the Summoner"] = "Novos the Summoner",
	Noxxion = "Noxxion",
	["Obsidian Sentinel"] = "Obsidian Sentinel",
	["Occu'thar"] = "Occu'thar",
	["Odo the Blindwatcher"] = "Odo the Blindwatcher",
	Oggleflint = "Oggleflint",
	["Ogom the Wretched"] = "Ogom the Wretched",
	Ohgan = "Ohgan",
	["Ok'thor the Breaker"] = "Ok'thor the Breaker",
	Olaf = "Olaf",
	["Old Serra'kis"] = "Old Serra'kis",
	["Olm the Summoner"] = "Olm the Summoner",
	["Omnitron Defense System"] = "Omnitron Defense System",
	Omnotron = "Omnotron",
	["Omnotron Defense System"] = "Omnotron Defense System",
	["Omor the Unscarred"] = "Omor the Unscarred",
	Onyxia = "Onyxia",
	["Opera Event"] = "Opera Event",
	["Orgrim's Hammer"] = "Orgrim's Hammer",
	["Ormorok the Tree-Shaper"] = "Ormorok the Tree-Shaper",
	["Oro Eyegouge"] = "Oro Eyegouge",
	["Ossirian the Unscarred"] = "Ossirian the Unscarred",
	Ouro = "Ouro",
	["Overlord Ramtusk"] = "Overlord Ramtusk",
	["Overlord Wyrmthalak"] = "Overlord Wyrmthalak",
	["Overmaster Pyron"] = "Overmaster Pyron",
	["Overseer Tidewrath"] = "Overseer Tidewrath",
	Ozruk = "Ozruk",
	Ozumat = "Ozumat",
	Pandemonius = "Pandemonius",
	["Panzor the Invincible"] = "Panzor the Invincible",
	Patchwerk = "Patchwerk",
	["Pathaleon the Calculator"] = "Pathaleon the Calculator",
	["Peroth'arn"] = "Peroth'arn",
	Phalanx = "Phalanx",
	["Phaseshift Bulwark"] = "Phaseshift Bulwark",
	Pimgib = "Pimgib",
	["Plaguemaw the Rotting"] = "Plaguemaw the Rotting",
	["Plugger Spazzring"] = "Plugger Spazzring",
	["Postmaster Malown"] = "Postmaster Malown",
	["Priestess Delrissa"] = "Priestess Delrissa",
	["Prince Keleseth"] = "Prince Keleseth",
	["Prince Malchezaar"] = "Prince Malchezaar",
	["Prince Skaldrenox"] = "Prince Skaldrenox",
	["Prince Taldaram"] = "Prince Taldaram",
	["Prince Tenris Mirkblood"] = "Prince Tenris Mirkblood",
	["Prince Tortheldrin"] = "Prince Tortheldrin",
	["Prince Valanar"] = "Prince Valanar",
	["Princess Huhuran"] = "Princess Huhuran",
	["Princess Moira Bronzebeard"] = "Princess Moira Bronzebeard",
	["Princess Tempestria"] = "Princess Tempestria",
	["Princess Theradras"] = "Princess Theradras",
	["Princess Yauj"] = "Princess Yauj",
	["Professor Putricide"] = "Professor Putricide",
	["Pure Spawn of Hydross"] = "Pure Spawn of Hydross",
	Pusillin = "Pusillin",
	["Pyroguard Emberseer"] = "Pyroguard Emberseer",
	["Pyromancer Loregrain"] = "Pyromancer Loregrain",
	Quagmirran = "Quagmirran",
	["Quartermaster Zigris"] = "Quartermaster Zigris",
	["Queen Azshara"] = "Queen Azshara",
	["Rage Winterchill"] = "Rage Winterchill",
	Ragglesnout = "Ragglesnout",
	["Raging Spirit"] = "Raging Spirit",
	Ragnaros = "Ragnaros",
	Rajh = "Rajh",
	["Ramstein the Gorger"] = "Ramstein the Gorger",
	["Randolph Moloch"] = "Randolph Moloch",
	["Ras Frostwhisper"] = "Ras Frostwhisper",
	Rattlegore = "Rattlegore",
	["Razorclaw the Butcher"] = "Razorclaw the Butcher",
	["Razorgore the Untamed"] = "Razorgore the Untamed",
	Razorlash = "Razorlash",
	Razorscale = "Razorscale",
	["Reliquary of Souls"] = "Reliquary of Souls",
	Renataki = "Renataki",
	["Restless Skeleton"] = "Restless Skeleton",
	Rethilgore = "Rethilgore",
	Revelosh = "Revelosh",
	["Rhahk'Zor"] = "Rhahk'Zor",
	["Ribbly Screwspigot"] = "Ribbly Screwspigot",
	["Right Arm"] = "Right Arm",
	["Ring of Law"] = "Ring of Law",
	["Risen Hammersmith"] = "Risen Hammersmith",
	Roar = "Roar",
	Rohash = "Rohash",
	["Rokad the Ravager"] = "Rokad the Ravager",
	["Rokdar the Sundered Lord"] = "Rokdar the Sundered Lord",
	["Rokmar the Crackler"] = "Rokmar the Crackler",
	["Rom'ogg Bonecrusher"] = "Rom'ogg Bonecrusher",
	Romulo = "Romulo",
	["Romulo & Julianne"] = "Romulo & Julianne",
	Roogug = "Roogug",
	Rotface = "Rotface",
	Rotgrip = "Rotgrip",
	["Runemaster Molgeim"] = "Runemaster Molgeim",
	["Runok Wildmane"] = "Runok Wildmane",
	Ruuzlu = "Ruuzlu",
	["Salramm the Fleshcrafter"] = "Salramm the Fleshcrafter",
	["Sanctum Sentry"] = "Sanctum Sentry",
	["Sandarr Dunereaver"] = "Sandarr Dunereaver",
	["Sandfury Executioner"] = "Sandfury Executioner",
	Sapphiron = "Sapphiron",
	Sara = "Sara",
	["Saronite Animus"] = "Saronite Animus",
	Sartharion = "Sartharion",
	["Sathrovarr the Corruptor"] = "Sathrovarr the Corruptor",
	["Saviana Ragefire"] = "Saviana Ragefire",
	["Scarlet Commander Mograine"] = "Scarlet Commander Mograine",
	["Scourgelord Tyrannus"] = "Scourgelord Tyrannus",
	["Seeth'rel"] = "Seeth'rel",
	["Selin Fireheart"] = "Selin Fireheart",
	["Sergeant Bly"] = "Sergeant Bly",
	Setesh = "Setesh",
	["Shade of Akama"] = "Shade of Akama",
	["Shade of Aran"] = "Shade of Aran",
	["Shade of Eranikus"] = "Shade of Eranikus",
	["Shadikith the Glider"] = "Shadikith the Glider",
	["Shadow Hunter Vosh'gajin"] = "Shadow Hunter Vosh'gajin",
	["Shadow of Leotheras"] = "Shadow of Leotheras",
	["Shadowpriest Sezz'ziz"] = "Shadowpriest Sezz'ziz",
	Shadron = "Shadron",
	Shannox = "Shannox",
	Shazzrah = "Shazzrah",
	["Shirrak the Dead Watcher"] = "Shirrak the Dead Watcher",
	["Siamat, Lord of South Wind"] = "Siamat, Lord of South Wind",
	Sindragosa = "Sindragosa",
	Sinestra = "Sinestra",
	["Sir Zeliek"] = "Sir Zeliek",
	["Sjonnir The Ironshaper"] = "Sjonnir The Ironshaper",
	["Skadi the Ruthless"] = "Skadi the Ruthless",
	["Skarr the Unbreakable"] = "Skarr the Unbreakable",
	["Skarvald the Constructor"] = "Skarvald the Constructor",
	["Skra'gath"] = "Skra'gath",
	Skul = "Skul",
	Skum = "Skum",
	Slabhide = "Slabhide",
	["Slad'ran"] = "Slad'ran",
	Sneed = "Sneed",
	["Sneed's Shredder"] = "Sneed's Shredder",
	["Solakar Flamewreath"] = "Solakar Flamewreath",
	["Solarium Agent"] = "Solarium Agent",
	["Solarium Priest"] = "Solarium Priest",
	["Spine of Deathwing"] = "Spine of Deathwing",
	["Spirestone Battle Lord"] = "Spirestone Battle Lord",
	["Spirestone Butcher"] = "Spirestone Butcher",
	["Spirestone Lord Magus"] = "Spirestone Lord Magus",
	["Staff of Disintegration"] = "Staff of Disintegration",
	Stalagg = "Stalagg",
	Steelbreaker = "Steelbreaker",
	["Stomper Kreeg"] = "Stomper Kreeg",
	Stonespine = "Stonespine",
	["Stormcaller Brundir"] = "Stormcaller Brundir",
	Strawman = "Strawman",
	["Sulfuron Harbinger"] = "Sulfuron Harbinger",
	Supremus = "Supremus",
	["Svala Sorrowgrave"] = "Svala Sorrowgrave",
	["Swamplord Musel'ek"] = "Swamplord Musel'ek",
	Taerar = "Taerar",
	["Tainted Spawn of Hydross"] = "Tainted Spawn of Hydross",
	["Talon King Ikiss"] = "Talon King Ikiss",
	["Taragaman the Hungerer"] = "Taragaman the Hungerer",
	["Targorr the Dread"] = "Targorr the Dread",
	Tavarok = "Tavarok",
	Techbot = "Techbot",
	["Temple Guardian Anhuur"] = "Temple Guardian Anhuur",
	Temporus = "Temporus",
	["Tendris Warpwood"] = "Tendris Warpwood",
	Tenebron = "Tenebron",
	["Terestian Illhoof"] = "Terestian Illhoof",
	["Teron Gorefiend"] = "Teron Gorefiend",
	Terrastra = "Terrastra",
	Thaddius = "Thaddius",
	["Thaladred the Darkener"] = "Thaladred the Darkener",
	["Thane Korth'azz"] = "Thane Korth'azz",
	["The Beast"] = "The Beast",
	["The Beasts of Northrend"] = "The Beasts of Northrend",
	["The Big Bad Wolf"] = "The Big Bad Wolf",
	["The Black Knight"] = "The Black Knight",
	["The Black Stalker"] = "The Black Stalker",
	["The Blue Brothers"] = "The Blue Brothers",
	["The Bug Family"] = "The Bug Family",
	["The Crone"] = "The Crone",
	["The Curator"] = "The Curator",
	["The Eredar Twins"] = "The Eredar Twins",
	["The Four Horsemen"] = "The Four Horsemen",
	["The Illidari Council"] = "The Illidari Council",
	["The Iron Council"] = "The Iron Council",
	["The Lich King"] = "The Lich King",
	["The Lost Dwarves"] = "The Lost Dwarves",
	["The Lurker Below"] = "The Lurker Below",
	["The Maker"] = "The Maker",
	["The Prophet Skeram"] = "The Prophet Skeram",
	["The Prophet Tharon'ja"] = "The Prophet Tharon'ja",
	["The Ravenian"] = "The Ravenian",
	["The Razza"] = "The Razza",
	["The Seven Dwarves"] = "The Seven Dwarves",
	["The Skybreaker"] = "The Skybreaker",
	["The Tribunal of Ages"] = "The Tribunal of Ages",
	["The Twin Emperors"] = "The Twin Emperors",
	["The Twin Val'kyr"] = "The Twin Val'kyr",
	["The Unforgiven"] = "The Unforgiven",
	["The Windreaver"] = "The Windreaver",
	["Theka the Martyr"] = "Theka the Martyr",
	Theralion = "Theralion",
	Thorim = "Thorim",
	["Thorngrin the Tender"] = "Thorngrin the Tender",
	["Tidewalker Lurker"] = "Tidewalker Lurker",
	["Timmy the Cruel"] = "Timmy the Cruel",
	Tinhead = "Tinhead",
	["Tinkerer Gizlock"] = "Tinkerer Gizlock",
	["Tirion Fordring"] = "Tirion Fordring",
	Tito = "Tito",
	["Toravon the Ice Watcher"] = "Toravon the Ice Watcher",
	Toxitron = "Toxitron",
	["Trigore the Lasher"] = "Trigore the Lasher",
	Trollgore = "Trollgore",
	["Tsu'zee"] = "Tsu'zee",
	["Tuten'kash"] = "Tuten'kash",
	["Twilight Lord Kelris"] = "Twilight Lord Kelris",
	Ultraxion = "Ultraxion",
	["Urok Doomhowl"] = "Urok Doomhowl",
	["VX-001"] = "VX-001",
	["Vaelastrasz the Corrupt"] = "Vaelastrasz the Corrupt",
	["Val'kyr Shadowguard"] = "Val'kyr Shadowguard",
	Valiona = "Valiona",
	["Valiona and Theralion"] = "Valiona and Theralion",
	["Valithria Dreamwalker"] = "Valithria Dreamwalker",
	["Vanessa VanCleef"] = "Vanessa VanCleef",
	["Varian Wrynn"] = "Varian Wrynn",
	["Varos Cloudstrider"] = "Varos Cloudstrider",
	Vazruden = "Vazruden",
	["Vazruden the Herald"] = "Vazruden the Herald",
	Vectus = "Vectus",
	Vem = "Vem",
	Veng = "Veng",
	["Veras Darkshadow"] = "Veras Darkshadow",
	["Verdan the Everliving"] = "Verdan the Everliving",
	Verek = "Verek",
	Vesperon = "Vesperon",
	Vexallus = "Vexallus",
	["Veyzhak the Cannibal"] = "Veyzhak the Cannibal",
	["Vile'rel"] = "Vile'rel",
	Viscidus = "Viscidus",
	["Viscous Fallout"] = "Viscous Fallout",
	["Void Reaver"] = "Void Reaver",
	Volkhan = "Volkhan",
	["War Master Voone"] = "War Master Voone",
	["Warbringer O'mrogg"] = "Warbringer O'mrogg",
	["Warchief Blackhand Piece"] = "Warchief Blackhand Piece",
	["Warchief Kargath Bladefist"] = "Warchief Kargath Bladefist",
	["Warchief Rend Blackhand"] = "Warchief Rend Blackhand",
	["Warden Mellichar"] = "Warden Mellichar",
	["Warder Stilgiss"] = "Warder Stilgiss",
	["Warlord Kalithresh"] = "Warlord Kalithresh",
	["Warlord Zon'ozz"] = "Warlord Zon'ozz",
	["Warmaster Blackhorn"] = "Warmaster Blackhorn",
	["Warmaul Champion"] = "Warmaul Champion",
	["Warp Slicer"] = "Warp Slicer",
	["Warp Splinter"] = "Warp Splinter",
	["Watchkeeper Gargolmar"] = "Watchkeeper Gargolmar",
	Weaver = "Weaver",
	["Willey Hopebreaker"] = "Willey Hopebreaker",
	["Witch Doctor Zum'rah"] = "Witch Doctor Zum'rah",
	["Wolf Master Nandos"] = "Wolf Master Nandos",
	["Wrath-Scryer Soccothrates"] = "Wrath-Scryer Soccothrates",
	Wushoolay = "Wushoolay",
	["XT-002 Deconstructor"] = "XT-002 Deconstructor",
	Xevozz = "Xevozz",
	["Yogg-Saron"] = "Yogg-Saron",
	Yor = "Yor",
	["Yor'sahj the Unsleeping"] = "Yor'sahj the Unsleeping",
	Ysondre = "Ysondre",
	Zanzil = "Zanzil",
	Zekkis = "Zekkis",
	["Zelemar the Wrathful"] = "Zelemar the Wrathful",
	["Zereketh the Unbound"] = "Zereketh the Unbound",
	Zerillis = "Zerillis",
	["Zevrim Thornhoof"] = "Zevrim Thornhoof",
	Zolo = "Zolo",
	["Zul'Farrak Dead Hero"] = "Zul'Farrak Dead Hero",
	["Zul'Lor"] = "Zul'Lor",
	["Zul'jin"] = "Zul'jin",
	["Zul'tore"] = "Zul'tore",
	["Zuramat the Obliterator"] = "Zuramat the Obliterator",
}


if GAME_LOCALE == "enUS" then
	lib:SetCurrentTranslations(true)
elseif GAME_LOCALE == "zhCN" then
	lib:SetCurrentTranslations {
	["\"Captain\" Cookie"] = "“船长”曲奇",
	Acidmaw = "酸喉",
	["Admiral Ripsnarl"] = "撕心狼将军",
	Aeonus = "埃欧努斯",
	["Aerial Command Unit"] = "空中指挥单位",
	["Agathelos the Raging"] = "暴怒的阿迦赛罗斯",
	["Aggem Thorncurse"] = "阿格姆",
	Ahune = "埃霍恩",
	["Akil'zon"] = "埃基尔松",
	["Aku'mai"] = "阿库麦尔",
	["Al'Akir"] = "奥拉基尔",
	["Al'ar"] = "奥",
	["Algalon the Observer"] = "观察者奥尔加隆",
	Altairus = "阿尔泰鲁斯",
	Altarius = "阿尔泰鲁斯",
	Alysrazor = "奥利瑟拉佐尔",
	["Alzzin the Wildshaper"] = "奥兹恩",
	Amanitar = "埃曼尼塔",
	["Ambassador Flamelash"] = "弗莱拉斯大使",
	["Ambassador Hellmaw"] = "赫尔默大使",
	Ammunae = "阿穆纳伊",
	["Amnennar the Coldbringer"] = "寒冰之王亚门纳尔",
	["Ancient Stone Keeper"] = "古代的石头看守者",
	Anetheron = "安纳塞隆",
	["Anger'rel"] = "安格雷尔",
	Anomalus = "阿诺玛鲁斯",
	Anraphet = "安拉斐特",
	Anshal = "安舍尔",
	["Antu'sul"] = "安图苏尔",
	["Anub'Rekhan"] = "阿努布雷坎",
	["Anub'arak"] = "阿努巴拉克",
	["Anub'shiah"] = "阿努希尔",
	["Anubisath Defender"] = "阿努比萨斯防御者",
	["Anubisath Guardian"] = "阿努比萨斯守卫者",
	Anzu = "安苏",
	["Arcane Watchman"] = "奥术看守",
	["Arcanist Doan"] = "奥法师杜安",
	Arcanotron = "奥能金刚",
	Archaedas = "阿扎达斯",
	["Archavon the Stone Watcher"] = "岩石看守者阿尔卡冯",
	["Archbishop Benedictus"] = "大主教本尼迪塔斯",
	Archimonde = "阿克蒙德",
	["Archivist Galford"] = "档案管理员加尔福特",
	["Archmage Arugal"] = "大法师阿鲁高",
	Arcurion = "阿奎里恩",
	Argaloth = "阿尔加洛斯",
	["Argent Confessor Paletress"] = "银色神官帕尔崔丝",
	Arion = "艾里昂",
	["Arugal's Voidwalker"] = "阿鲁高的虚空行者",
	Asaad = "阿萨德",
	["Ascendant Council"] = "升腾者议会",
	["Ascendant Lord Obsidius"] = "升腾者领主奥西迪斯",
	["Asim al Akir"] = "焦化披风",
	["Asira Dawnslayer"] = "埃希拉·黎明克星",
	["Assault Bot"] = "突击机器人",
	["Assembly of Iron"] = "钢铁议会",
	["Atal'alarion"] = "阿塔拉利恩",
	Atramedes = "艾卓曼德斯",
	["Attumen the Huntsman"] = "猎手阿图门",
	Auriaya = "欧尔莉亚",
	Avalanchion = "阿瓦兰奇奥",
	["Avatar of Hakkar"] = "哈卡的化身",
	["Ayamiss the Hunter"] = "狩猎者阿亚米斯",
	Azgalor = "阿兹加洛",
	["Azshir the Sleepless"] = "永醒的艾希尔",
	Azuregos = "艾索雷葛斯",
	["Bael'Gar"] = "贝尔加",
	Baelog = "巴尔洛戈",
	Baleroc = "贝尔洛克",
	Balnazzar = "巴纳扎尔",
	["Baltharus the Warborn"] = "战争之子巴尔萨鲁斯",
	["Bannok Grimaxe"] = "班诺克·巨斧",
	["Baron Aquanis"] = "阿奎尼斯男爵",
	["Baron Ashbury"] = "埃什博瑞男爵",
	["Baron Charr"] = "火焰男爵查尔",
	["Baron Geddon"] = "迦顿男爵",
	["Baron Kazum"] = "卡苏姆男爵",
	["Baron Rivendare"] = "瑞文戴尔男爵",
	["Baron Silverlaine"] = "席瓦莱恩男爵",
	["Baroness Anastari"] = "安娜丝塔丽男爵夫人",
	["Battleguard Sartura"] = "沙尔图拉",
	["Bazil Thredd"] = "巴基尔·斯瑞德",
	Bazzalan = "巴扎兰",
	Beauty = "如花",
	["Beth'tilac"] = "贝丝缇拉克",
	["Black Guard Swordsmith"] = "黑衣守卫铸剑师",
	["Blackheart the Inciter"] = "煽动者布莱卡特",
	["Blind Hunter"] = "盲眼猎手",
	["Blindeye the Seer"] = "盲眼先知",
	["Blood Council"] = "鲜血议会",
	["Blood Guard Porung"] = "血卫士伯鲁恩",
	["Blood Prince Council"] = "鲜血王子议会",
	["Blood Princes"] = "鲜血王子",
	["Blood Steward of Kirtonos"] = "基尔图诺斯的卫士",
	["Blood-Queen Lana'thel"] = "鲜血女王兰娜瑟尔",
	["Bloodlord Mandokir"] = "血领主曼多基尔",
	["Bloodmage Thalnos"] = "血法师萨尔诺斯",
	Boahn = "博艾恩",
	["Bomb Bot"] = "炸弹机器人",
	["Brain of Yogg-Saron"] = "尤格-萨隆的大脑",
	["Brainwashed Noble"] = "被洗脑的贵族",
	Broggok = "布洛戈克",
	Brokentoe = "断蹄",
	Bronjahm = "布隆亚姆",
	["Broodlord Lashlayer"] = "勒什雷尔",
	["Bruegal Ironknuckle"] = "布鲁高·铁拳",
	Brutallus = "布鲁塔卢斯",
	["Burning Felguard"] = "燃烧地狱卫士",
	["Buru the Gorger"] = "吞咽者布鲁",
	["C'Thun"] = "克苏恩",
	["Cache of the Firelord"] = "火焰之王的宝箱",
	["Cache of the Legion"] = "军团宝箱",
	["Cannon Master Willey"] = "炮手威利",
	["Captain Greenskin"] = "绿皮队长",
	["Captain Kromcrush"] = "克罗卡斯",
	["Captain Skarloc"] = "斯卡洛克上尉",
	["Captain Varo'then"] = "禁卫队长瓦罗森",
	["Celebras the Cursed"] = "被诅咒的塞雷布拉斯",
	["Charlga Razorflank"] = "卡尔加·刺肋",
	["Chess Event"] = "国际象棋",
	["Chest of The Seven"] = "七贤之箱",
	["Chief Ukorz Sandscalp"] = "乌克兹·沙顶",
	Chimaeron = "奇美隆",
	["Cho'Rush the Observer"] = "观察者克鲁什",
	["Cho'gall"] = "古加尔",
	Chromaggus = "克洛玛古斯",
	["Chrono Lord Deja"] = "时空领主德亚",
	["Chrono-Lord Epoch"] = "时光领主埃博克",
	Claw = "克劳恩",
	["Coilfang Elite"] = "盘牙精英",
	["Coilfang Strider"] = "盘牙巡逻者",
	["Commander Kolurg"] = "指挥官库鲁尔格",
	["Commander Malor"] = "狂热的玛洛尔",
	["Commander Sarannis"] = "指挥官萨拉妮丝",
	["Commander Springvale"] = "指挥官斯普林瓦尔",
	["Commander Stoutbeard"] = "指挥官斯托比德",
	["Commander Ulthok"] = "指挥官乌尔索克",
	["Conclave of Wind"] = "风之议会",
	["Constructor & Controller"] = "建筑师与控制者",
	Cookie = "曲奇",
	Corborus = "克伯鲁斯",
	["Coren Direbrew"] = "科林·烈酒",
	["Corla, Herald of Twilight"] = "柯尔拉",
	["Cosmic Infuser"] = "宇宙灌注者",
	["Crimson Hammersmith"] = "红衣铸锤师",
	["Crowd Pummeler 9-60"] = "群体打击者9-60",
	["Crystal Fang"] = "水晶之牙",
	Cyanigosa = "塞安妮苟萨",
	Daakara = "达卡拉",
	["Dalliah the Doomsayer"] = "末日预言者达尔莉安",
	["Dalronn the Controller"] = "控制者达尔隆",
	["Dark Coffer"] = "黑暗宝箱",
	["Dark Iron Ambassador"] = "黑铁大师",
	["Darkmaster Gandling"] = "黑暗院长加丁",
	["Darkweaver Syth"] = "黑暗编织者塞斯",
	["Death Knight Darkreaver"] = "死亡骑士达克雷尔",
	["Death Knight Understudy"] = "见习死亡骑士",
	["Death Speaker Jargba"] = "亡语者贾格巴",
	["Deathbound Ward"] = "缚亡守卫",
	["Deathbringer Saurfang"] = "死亡使者萨鲁法尔",
	["Deathspeaker High Priest"] = "亡语高阶祭司",
	["Deathstalker Visceri"] = "死亡猎手维赛里",
	["Deathsworn Captain"] = "死亡之誓",
	Devastation = "毁坏",
	["Deviate Faerie Dragon"] = "变异精灵龙",
	["Devourer of Souls"] = "噬魂者",
	["Dextren Ward"] = "迪克斯特·瓦德",
	["Digmaster Shovelphlange"] = "挖掘专家舒尔弗拉格",
	["Doctor Theolen Krastinov"] = "瑟尔林·卡斯迪诺夫教授",
	["Doom Lord Kazzak"] = "末日领主卡扎克",
	["Doom'rel"] = "杜姆雷尔",
	Doomwalker = "末日行者",
	["Dope'rel"] = "多普雷尔",
	Dorothee = "多萝茜",
	["Drahga Shadowburner"] = "达加·燃影者",
	["Drahga Shodowburner"] = "达加·燃影者",
	["Drakkari Colossus"] = "达卡莱巨像",
	["Drakos the Interrogator"] = "审讯者达库斯",
	Dreadscale = "恐鳞",
	Dreamscythe = "德姆塞卡尔",
	["Dust Covered Chest"] = "灰尘覆盖的箱子",
	Dustwraith = "灰尘怨灵",
	["Eadric the Pure"] = "纯洁者耶德瑞克",
	["Earthcaller Halmgar"] = "唤地者哈穆加",
	["Earthrager Ptah"] = "地怒者塔赫",
	Ebonroc = "埃博诺克",
	["Echo of Baine"] = "贝恩的残影",
	["Echo of Jaina"] = "吉安娜的残影",
	["Echo of Sylvanas"] = "希尔瓦娜斯的残影",
	["Echo of Tyrande"] = "泰兰德的残影",
	["Eck the Ferocious"] = "凶残的伊克",
	["Edwin VanCleef"] = "艾德温·范克里夫",
	["Elder Brightleaf"] = "明叶长老",
	["Elder Ironbranch"] = "铁枝长老",
	["Elder Nadox"] = "纳多克斯长老",
	["Elder Stonebark"] = "石树长老",
	["Electrocutioner 6000"] = "电刑器6000型",
	Electron = "电荷金刚",
	["Elementium Monstrosity"] = "源质畸体",
	["Emalon the Storm Watcher"] = "风暴看守者埃玛尔隆",
	Emeriss = "艾莫莉丝",
	["Emperor Dagran Thaurissan"] = "达格兰·索瑞森大帝",
	["Emperor Vek'lor"] = "维克洛尔大帝",
	["Emperor Vek'nilash"] = "维克尼拉斯大帝",
	Entropius = "熵魔",
	["Eonar's Gift"] = "艾欧娜尔的礼物",
	["Epoch Hunter"] = "时空猎手",
	Erekem = "埃雷克姆",
	["Eressea Dawnsinger"] = "埃蕾希·晨歌",
	["Eric \"The Swift\""] = "埃瑞克",
	Erudax = "埃鲁达克",
	["Erunak Stonespeaker"] = "石语者埃鲁纳克",
	["Essence of Anger"] = "愤怒精华",
	["Essence of Desire"] = "欲望精华",
	["Essence of Suffering"] = "苦痛精华",
	Eviscerator = "剜眼者",
	["Exarch Maladaar"] = "大主教玛拉达尔",
	["Expedition Commander"] = "远征军指挥官",
	["Eydis Darkbane"] = "黑暗邪使艾蒂丝",
	["Eye of C'Thun"] = "克苏恩之眼",
	["Faction Champions"] = "阵营冠军",
	["Fallen Champion"] = "死灵勇士",
	Falric = "法瑞克",
	["Falric and Marwyn"] = "法瑞克和玛维恩",
	["Fankriss the Unyielding"] = "顽强的范克瑞斯",
	["Fathom-Lord Karathress"] = "深水领主卡拉瑟雷斯",
	Felmyst = "菲米丝",
	Feludius = "费伦迪乌斯",
	["Fenrus the Devourer"] = "吞噬者芬鲁斯",
	["Feral Defender"] = "野性防御者",
	Festergut = "烂肠",
	Feugen = "费尔根",
	["Fineous Darkvire"] = "弗诺斯·达克维尔",
	Firemaw = "费尔默",
	["Fjola Lightbane"] = "光明邪使菲奥拉",
	["Flame Leviathan"] = "烈焰巨兽",
	Flamegor = "弗莱格尔",
	["Foe Reaper 5000"] = "死神5000",
	["Foreman Thistlenettle"] = "工头希斯耐特",
	["Forgemaster Garfrost"] = "熔炉之主加弗斯特",
	["Forgemaster Throngus"] = "铸炉之主索格乌斯",
	["Four Horsemen Chest"] = "四骑士之箱",
	["Fras Siabi"] = "弗拉斯·希亚比",
	Freya = "弗蕾亚",
	["Gahz'ranka"] = "加兹兰卡",
	["Gahz'rilla"] = "加兹瑞拉",
	["Gal'darah"] = "迦尔达拉",
	["Galgann Firehammer"] = "加加恩·火锤",
	Garr = "加尔",
	["Garrosh Hellscream"] = "加尔鲁什·地狱咆哮",
	Gasher = "加什尔",
	["Gatewatcher Gyro-Kill"] = "看守者盖罗基尔",
	["Gatewatcher Iron-Hand"] = "看守者埃隆汉",
	["Gathios the Shatterer"] = "击碎者加西奥斯",
	Gehennas = "基赫纳斯",
	Gelihast = "格里哈斯特",
	Gelk = "吉尔克",
	["General Angerforge"] = "安格弗将军",
	["General Bjarngrim"] = "比亚格里将军",
	["General Drakkisath"] = "达基萨斯将军",
	["General Husam"] = "胡辛姆将军",
	["General Rajaxx"] = "拉贾克斯将军",
	["General Umbriss"] = "乌比斯将军",
	["General Vezax"] = "维扎克斯将军",
	["General Zarithrian"] = "萨瑞瑟里安将军",
	["Ghamoo-ra"] = "加摩拉",
	["Ghaz'an"] = "加兹安",
	["Ghok Bashguud"] = "霍克·巴什古德",
	Gilnid = "基尔尼格",
	["Gizrul the Slavener"] = "奴役者基兹鲁尔",
	["Gloom'rel"] = "格鲁雷尔",
	Glubtok = "格拉布托克",
	Gluth = "格拉斯",
	Glutton = "暴食者",
	["Golem Lord Argelmach"] = "傀儡统帅阿格曼奇",
	["Golemagg the Incinerator"] = "焚化者古雷曼格",
	["Goraluk Anvilcrack"] = "古拉鲁克",
	["Gormok the Impaler"] = "穿刺者戈莫克",
	["Gorosh the Dervish"] = "修行者高罗什",
	["Gortok Palehoof"] = "戈托克·苍蹄",
	["Gothik the Harvester"] = "收割者戈提克",
	["Grand Astromancer Capernian"] = "星术师卡波妮娅",
	["Grand Champions"] = "总冠军",
	["Grand Crusader Dathrohan"] = "大十字军战士达索汉",
	["Grand Magus Telestra"] = "大魔导师泰蕾丝塔",
	["Grand Vizier Ertan"] = "大宰相埃尔坦",
	["Grand Warlock Alythess"] = "高阶术士奥蕾塞丝",
	["Grand Warlock Nethekurse"] = "高阶术士奈瑟库斯",
	["Grand Widow Faerlina"] = "黑女巫法琳娜",
	["Grandmaster Vorpil"] = "沃匹尔大师",
	Grandmother = "老奶奶",
	["Grethok the Controller"] = "黑翼控制者",
	["Gri'lek"] = "格里雷克",
	Grimlok = "格瑞姆洛克",
	Grizzle = "格里兹尔",
	Grobbulus = "格罗布鲁斯",
	Grubbis = "格鲁比斯",
	["Gruul the Dragonkiller"] = "屠龙者格鲁尔",
	["Guard Fengus"] = "卫兵芬古斯",
	["Guard Mol'dar"] = "卫兵摩尔达",
	["Guard Slip'kik"] = "卫兵斯里基克",
	["Guardian of Yogg-Saron"] = "尤格-萨隆的卫士",
	["Gurtogg Bloodboil"] = "古尔图格·血沸",
	Gyth = "盖斯",
	Hadronox = "哈多诺克斯",
	["Hagara the Stormbinder"] = "缚风者哈格拉",
	Hakkar = "哈卡",
	Halazzi = "哈尔拉兹",
	["Halfus Wyrmbreaker"] = "哈尔弗斯·碎龙者",
	Halion = "海里昂",
	Halycon = "哈雷肯",
	Hamhock = "哈姆霍克",
	["Harbinger Skyriss"] = "预言者斯克瑞斯",
	["Hate'rel"] = "黑特雷尔",
	["Hazza'rah"] = "哈扎拉尔",
	Hazzas = "哈扎斯",
	["Headless Horseman"] = "无头骑士",
	["Hearthsinger Forresten"] = "弗雷斯特恩",
	["Hedrum the Creeper"] = "爬行者赫杜姆",
	["Heigan the Unclean"] = "肮脏的希尔盖",
	["Helix Gearbreaker"] = "赫利克斯·破甲",
	["Hellfire Channeler"] = "地狱火导魔者",
	["Henry Stern"] = "亨利·斯特恩",
	["Herald Volazj"] = "传令官沃拉兹",
	Herod = "赫洛德",
	["Hex Lord Malacrass"] = "妖术领主玛拉卡斯",
	["High Astromancer Solarian"] = "大星术师索兰莉安",
	["High Botanist Freywinn"] = "高级植物学家弗雷温",
	["High Inquisitor Fairbanks"] = "大检察官法尔班克斯",
	["High Inquisitor Whitemane"] = "大检察官怀特迈恩",
	["High Interrogator Gerstahn"] = "审讯官格斯塔恩",
	["High King Maulgar"] = "莫加尔大王",
	["High Marshal Whirlaxis"] = "大元帅维拉希斯",
	["High Nethermancer Zerevor"] = "高阶灵术师塞勒沃尔",
	["High Overlord Saurfang"] = "萨鲁法尔大王",
	["High Priest Thekal"] = "高阶祭司塞卡尔",
	["High Priest Venoxis"] = "高阶祭司温诺希斯",
	["High Priestess Arlokk"] = "高阶祭司娅尔罗",
	["High Priestess Azil"] = "高阶女祭司艾苏尔",
	["High Priestess Jeklik"] = "高阶祭司耶克里克",
	["High Priestess Kilnara"] = "高阶祭司基尔娜拉",
	["High Priestess Mar'li"] = "高阶祭司玛尔里",
	["High Priestess of Thaurissan"] = "索瑞森高阶女祭司",
	["High Prophet Barim"] = "高阶预言者巴林姆",
	["High Warlord Naj'entus"] = "高阶督军纳因图斯",
	["Highlord Mograine"] = "大领主莫格莱尼",
	["Highlord Omokk"] = "欧莫克大王",
	Hodir = "霍迪尔",
	Hogger = "霍格",
	["Houndmaster Grebmar"] = "驯犬者格雷布玛尔",
	["Houndmaster Loksey"] = "驯犬者洛克希",
	Hukku = "胡库",
	Hungarfen = "霍加尔芬",
	["Hurley Blackbreath"] = "霍尔雷·黑须",
	["Hyakiss the Lurker"] = "潜伏者希亚其斯",
	["Hydromancer Thespia"] = "水术师瑟丝比娅",
	["Hydromancer Velratha"] = "水占师维蕾萨",
	Hydrospawn = "海多斯博恩",
	["Hydross the Unstable"] = "不稳定的海度斯",
	["Ice Sphere"] = "寒冰之球",
	["Icecrown Gunship Battle"] = "冰冠炮舰战斗",
	Icehowl = "冰吼",
	Ichoron = "艾库隆",
	Ick = "伊克",
	Ignacious = "伊格纳休斯",
	["Ignis the Furnace Master"] = "掌炉者伊格尼斯",
	["Illidan Stormrage"] = "伊利丹·怒风",
	["Illidari Council"] = "伊利达雷议会",
	["Illyanna Ravenoak"] = "伊琳娜·暗木",
	["Immol'thar"] = "伊莫塔尔",
	["Infinite Corruptor"] = "永恒腐蚀者",
	["Infinity Blades"] = "无尽之刃",
	["Ingvar the Plunderer"] = "劫掠者因格瓦尔",
	["Instructor Galford"] = "档案管理员加尔福特",
	["Instructor Malicia"] = "讲师玛丽希亚",
	["Instructor Razuvious"] = "教官拉苏维奥斯",
	["Interrogator Vishas"] = "审讯员韦沙斯",
	Ionar = "艾欧纳尔",
	Ironaya = "艾隆纳亚",
	Ironspine = "铁脊死灵",
	Isalien = "伊萨利恩",
	Isiset = "伊希斯特",
	Jade = "玉龙",
	["Jammal'an the Prophet"] = "预言者迦玛兰",
	["Jan'alai"] = "加亚莱",
	["Jandice Barov"] = "詹迪斯·巴罗夫",
	["Jed Runewatcher"] = "杰德",
	["Jedoga Shadowseeker"] = "耶戈达·觅影者",
	["Jergosh the Invoker"] = "祈求者耶戈什",
	["Jin'do the Godbreaker"] = "碎神者金度",
	["Jin'do the Hexxer"] = "妖术师金度",
	["Jormungar Behemoth"] = "蛰猛巨虫",
	Jormungars = "冰虫",
	Julianne = "朱丽叶",
	["Junk Bot"] = "废物机器人",
	["Kael'thas Sunstrider"] = "凯尔萨斯·逐日者",
	Kalecgos = "卡雷苟斯",
	["Kam Deepfury"] = "卡姆·深怒",
	["Karsh Steelbender"] = "卡尔什·断钢",
	["Kaz'rogal"] = "卡兹洛加",
	["Kazkaz the Unholy"] = "邪恶的卡萨卡兹",
	["Kel'Thuzad"] = "克尔苏加德",
	["Keli'dan the Breaker"] = "击碎者克里丹",
	Keristrasza = "克莉斯塔萨",
	["Kiggler the Crazed"] = "疯狂的基戈尔",
	["Kil'jaeden"] = "基尔加丹",
	["Kil'rek"] = "基尔里克",
	["King Dred"] = "暴龙之王爵德",
	["King Gordok"] = "戈多克大王",
	["King Llane Piece"] = "莱恩国王",
	["King Ymiron"] = "伊米隆国王",
	["Kirtonos the Herald"] = "传令官基尔图诺斯",
	["Knot Thimblejack's Cache"] = "诺特·希姆加克的储物箱",
	Kolk = "考尔克",
	Kologarn = "科隆加恩",
	["Koralon the Flame Watcher"] = "火焰看守者科拉隆",
	Kormok = "库尔莫克",
	Kresh = "克雷什",
	Krick = "科里克",
	["Krick and Ick"] = "科里克和伊克",
	["Krik'thir the Gatewatcher"] = "看门者克里克希尔",
	["Krosh Firehand"] = "克洛什·火拳",
	Krystallus = "克莱斯塔卢斯",
	Kurinnaxx = "库林纳克斯",
	["Lady Anacondra"] = "安娜科德拉",
	["Lady Blaumeux"] = "女公爵布劳缪克丝",
	["Lady Deathwhisper"] = "亡语者女士",
	["Lady Illucia Barov"] = "伊露希亚·巴罗夫",
	["Lady Malande"] = "女公爵玛兰德",
	["Lady Naz'jar"] = "纳兹夏女士",
	["Lady Sacrolash"] = "萨洛拉丝女王",
	["Lady Sarevess"] = "萨利维丝",
	["Lady Vashj"] = "瓦丝琪",
	Laj = "拉伊",
	Landslide = "兰斯利德",
	Lavanthor = "拉文索尔",
	["Left Arm"] = "左臂",
	["Leotheras the Blind"] = "盲眼者莱欧瑟拉斯",
	Lethon = "莱索恩",
	Lethtendris = "蕾瑟塔蒂丝",
	["Leviathan Mk II"] = "巨兽二型",
	["Ley-Guardian Eregos"] = "魔网守护者埃雷苟斯",
	["Lieutenant Drake"] = "德拉克中尉",
	["Lieutenant General Andorov"] = "安多洛夫中将",
	Loatheb = "洛欧塞布",
	Lockmaw = "锁喉",
	Loken = "洛肯",
	["Lord Alexei Barov"] = "阿雷克斯·巴罗夫",
	["Lord Aurius Rivendare"] = "奥里克斯·瑞文戴尔领主",
	["Lord Cobrahn"] = "考布莱恩",
	["Lord Godfrey"] = "高弗雷勋爵",
	["Lord Hel'nurath"] = "赫尔努拉斯",
	["Lord Incendius"] = "伊森迪奥斯",
	["Lord Jaraxxus"] = "加拉克苏斯大王",
	["Lord Kazzak"] = "末日领主卡扎克",
	["Lord Kri"] = "克里勋爵",
	["Lord Marrowgar"] = "玛洛加尔领主",
	["Lord Overheat"] = "灼热勋爵",
	["Lord Pythas"] = "皮萨斯",
	["Lord Rhyolith"] = "雷奥利斯领主",
	["Lord Roccor"] = "洛考尔",
	["Lord Sanguinar"] = "萨古纳尔男爵",
	["Lord Serpentis"] = "瑟芬迪斯",
	["Lord Skwol"] = "斯古恩男爵",
	["Lord Valthalak"] = "瓦塔拉克公爵",
	["Lord Victor Nefarius"] = "维克多·奈法里奥斯",
	["Lord Vyletongue"] = "维利塔恩",
	["Lord Walden"] = "沃登勋爵",
	["Lorekeeper Polkelt"] = "博学者普克尔特",
	["Lorgus Jett"] = "洛古斯·杰特",
	Loro = "洛若尔",
	Lucifron = "鲁西弗隆",
	["M'uru"] = "穆鲁",
	["Mad Magglish"] = "疯狂的马格利什",
	["Madness of Deathwing"] = "疯狂的死亡之翼",
	Maexxna = "迈克斯纳",
	["Mage-Lord Urom"] = "法师领主伊洛姆",
	["Magister Kalendris"] = "卡雷迪斯镇长",
	["Magistrate Barthilas"] = "巴瑟拉斯镇长",
	Magmadar = "玛格曼达",
	Magmatron = "熔岩金刚",
	Magmaw = "熔喉",
	Magmus = "玛格姆斯",
	Magra = "玛格拉",
	Magtheridon = "玛瑟里顿",
	["Maiden of Grief"] = "悲伤圣女",
	["Maiden of Virtue"] = "贞节圣女",
	["Majordomo Executus"] = "管理者埃克索图斯",
	["Majordomo Staghelm"] = "管理者鹿盔",
	["Mal'Ganis"] = "玛尔加尼斯",
	Malacrass = "玛拉卡斯",
	["Maleki the Pallid"] = "苍白的玛勒基",
	Maloriak = "马洛拉克",
	Malygos = "玛里苟斯",
	Mannoroth = "玛诺洛斯",
	Maraudos = "玛拉多斯",
	["Marduk Blackpool"] = "马杜克·布莱克波尔",
	["Marisa du'Paige"] = "玛里莎·杜派格",
	Marwyn = "玛维恩",
	["Master Engineer Telonicus"] = "首席技师塔隆尼库斯",
	["Maur Grimtotem"] = "玛尔·恐怖图腾",
	Meathook = "肉钩",
	["Mechano-Lord Capacitus"] = "机械领主卡帕西图斯",
	Medivh = "麦迪文",
	["Mekgineer Steamrigger"] = "机械师斯蒂里格",
	["Mekgineer Thermaplugg"] = "麦克尼尔·瑟玛普拉格",
	["Mennu the Betrayer"] = "背叛者门努",
	["Meshlok the Harvester"] = "收割者麦什洛克",
	Midnight = "午夜",
	Mijan = "米杉",
	Mimiron = "米米尔隆",
	["Mindbender Ghur'sha"] = "蛊心魔古厄夏",
	["Miner Johnson"] = "矿工约翰森",
	["Mistress of Pain"] = "痛苦女王",
	Moam = "莫阿姆",
	Mogor = "穆戈尔",
	["Mokra the Skullcrusher"] = "碎颅者莫克拉",
	Moorabi = "莫拉比",
	["Mor Grayhoof"] = "莫尔·灰蹄",
	Moragg = "摩拉格",
	Morchok = "莫卓克",
	["Mordresh Fire Eye"] = "火眼莫德雷斯",
	Moroes = "莫罗斯",
	["Morogrim Tidewalker"] = "莫洛格里·踏潮者",
	Morphaz = "摩弗拉斯",
	["Mother Shahraz"] = "莎赫拉丝主母",
	["Mother Smolderweb"] = "烟网蛛后",
	["Mr. Smite"] = "重拳先生",
	["Muradin Bronzebeard"] = "穆拉丁·铜须",
	["Murkblood Twin"] = "暗血双子",
	["Murkblood Twins"] = "暗血双子",
	Murmur = "摩摩尔",
	Murozond = "姆诺兹多",
	["Murta Grimgut"] = "穆尔塔",
	Mushgog = "姆斯高格",
	["Mutanus the Devourer"] = "吞噬者穆坦努斯",
	Nalorakk = "纳洛拉克",
	Nazan = "纳杉",
	Nefarian = "奈法利安",
	["Nefarian's End"] = "奈法利安的末日",
	["Nekrum Gutchewer"] = "耐克鲁姆",
	["Nerub'enkan"] = "奈鲁布恩坎",
	["Nethermancer Sepethrea"] = "灵术师塞比瑟蕾",
	Netherspite = "虚空幽龙",
	["Netherstrand Longbow"] = "灵弦长弓",
	["Nexus-Prince Shaffar"] = "节点亲王沙法尔",
	Nezir = "尼希尔",
	Nightbane = "夜之魇",
	["Noth the Plaguebringer"] = "药剂师诺斯",
	["Novos the Summoner"] = "召唤者诺沃斯",
	Noxxion = "诺克赛恩",
	["Obsidian Sentinel"] = "黑曜石哨兵",
	["Occu'thar"] = "欧库塔尔",
	["Odo the Blindwatcher"] = "盲眼守卫奥杜",
	Oggleflint = "奥格弗林特",
	["Ogom the Wretched"] = "可悲的奥戈姆",
	Ohgan = "奥根",
	["Ok'thor the Breaker"] = "破坏者奥科索尔",
	Olaf = "奥拉夫",
	["Old Serra'kis"] = "瑟拉吉斯",
	["Olm the Summoner"] = "召唤者沃尔姆",
	["Omnitron Defense System"] = "全能金刚防御系统",
	Omnotron = "全能金刚",
	["Omnotron Defense System"] = "全能金刚防御系统",
	["Omor the Unscarred"] = "无疤者奥摩尔",
	Onyxia = "奥妮克希亚",
	["Opera Event"] = "歌剧院",
	["Orgrim's Hammer"] = "奥格瑞姆之锤",
	["Ormorok the Tree-Shaper"] = "塑树者奥莫洛克",
	["Oro Eyegouge"] = "欧罗·血眼",
	["Ossirian the Unscarred"] = "无疤者奥斯里安",
	Ouro = "奥罗",
	["Overlord Ramtusk"] = "主宰拉姆塔斯",
	["Overlord Wyrmthalak"] = "维姆萨拉克",
	["Overmaster Pyron"] = "征服者派隆",
	["Overseer Tidewrath"] = "工头泰德瓦斯",
	Ozruk = "欧泽鲁克",
	Ozumat = "厄祖玛特",
	Pandemonius = "潘德莫努斯",
	["Panzor the Invincible"] = "无敌的潘佐尔",
	Patchwerk = "帕奇维克",
	["Pathaleon the Calculator"] = "计算者帕萨雷恩",
	["Peroth'arn"] = "佩罗萨恩",
	Phalanx = "方阵",
	["Phaseshift Bulwark"] = "相位壁垒",
	Pimgib = "匹姆吉布",
	["Plaguemaw the Rotting"] = "腐烂的普雷莫尔",
	["Plugger Spazzring"] = "普拉格",
	["Postmaster Malown"] = "邮差马龙",
	["Priestess Delrissa"] = "女祭司德莉希亚",
	["Prince Keleseth"] = "凯雷塞斯王子",
	["Prince Malchezaar"] = "玛克扎尔王子",
	["Prince Skaldrenox"] = "斯卡德诺克斯王子",
	["Prince Taldaram"] = "塔达拉姆王子",
	["Prince Tenris Mirkblood"] = "特里斯·黯血王子",
	["Prince Tortheldrin"] = "托塞德林王子",
	["Prince Valanar"] = "瓦拉纳王子",
	["Princess Huhuran"] = "哈霍兰公主",
	["Princess Moira Bronzebeard"] = "铁炉堡公主茉艾拉·铜须",
	["Princess Tempestria"] = "泰比斯蒂亚公主",
	["Princess Theradras"] = "瑟莱德丝公主",
	["Princess Yauj"] = "亚尔基公主",
	["Professor Putricide"] = "普崔塞德教授",
	["Pure Spawn of Hydross"] = "纯净的海度斯爪牙",
	Pusillin = "普希林",
	["Pyroguard Emberseer"] = "烈焰卫士艾博希尔",
	["Pyromancer Loregrain"] = "控火师罗格雷恩",
	Quagmirran = "夸格米拉",
	["Quartermaster Zigris"] = "军需官兹格雷斯",
	["Queen Azshara"] = "艾萨拉女王",
	["Rage Winterchill"] = "雷基·冬寒",
	Ragglesnout = "拉戈斯诺特",
	["Raging Spirit"] = "暴怒的灵魂",
	Ragnaros = "拉格纳罗斯",
	Rajh = "拉夏",
	["Ramstein the Gorger"] = "吞咽者拉姆斯登",
	["Randolph Moloch"] = "兰多菲·摩洛克",
	["Ras Frostwhisper"] = "莱斯·霜语",
	Rattlegore = "血骨傀儡",
	["Razorclaw the Butcher"] = "屠夫拉佐克劳",
	["Razorgore the Untamed"] = "狂野的拉佐格尔",
	Razorlash = "锐刺鞭笞者",
	Razorscale = "锋鳞",
	["Reliquary of Souls"] = "灵魂之匣",
	Renataki = "雷纳塔基",
	["Restless Skeleton"] = "无法安息的骷髅",
	Rethilgore = "雷希戈尔",
	Revelosh = "鲁维罗什",
	["Rhahk'Zor"] = "拉克佐",
	["Ribbly Screwspigot"] = "雷布里·斯库比格特",
	["Right Arm"] = "右臂",
	["Ring of Law"] = "秩序竞技场",
	["Risen Hammersmith"] = "红衣铸锤师",
	Roar = "胆小的狮子",
	Rohash = "洛哈西",
	["Rokad the Ravager"] = "蹂躏者洛卡德",
	["Rokdar the Sundered Lord"] = "裂石之王洛卡达尔",
	["Rokmar the Crackler"] = "巨钳鲁克玛尔",
	["Rom'ogg Bonecrusher"] = "摧骨者罗姆欧格",
	Romulo = "罗密欧",
	["Romulo & Julianne"] = "罗密欧与朱丽叶",
	Roogug = "鲁古",
	Rotface = "腐面",
	Rotgrip = "洛特格里普",
	["Runemaster Molgeim"] = "符文大师莫尔基姆",
	["Runok Wildmane"] = "鲁诺克·蛮鬃",
	Ruuzlu = "卢兹鲁",
	["Salramm the Fleshcrafter"] = "塑血者沙尔拉姆",
	["Sanctum Sentry"] = "圣所警卫",
	["Sandarr Dunereaver"] = "杉达尔·沙掠者",
	["Sandfury Executioner"] = "沙怒刽子手",
	Sapphiron = "萨菲隆",
	Sara = "萨拉",
	["Saronite Animus"] = "萨隆邪铁畸体",
	Sartharion = "萨塔里奥",
	["Sathrovarr the Corruptor"] = "腐蚀者萨索瓦尔",
	["Saviana Ragefire"] = "塞维娅娜·怒火",
	["Scarlet Commander Mograine"] = "血色十字军指挥官莫格莱尼",
	["Scourgelord Tyrannus"] = "天灾领主泰兰努斯",
	["Seeth'rel"] = "西斯雷尔",
	["Selin Fireheart"] = "塞林·火心",
	["Sergeant Bly"] = "布莱中士",
	Setesh = "塞特斯",
	["Shade of Akama"] = "阿卡玛之影",
	["Shade of Aran"] = "埃兰之影",
	["Shade of Eranikus"] = "伊兰尼库斯的阴影",
	["Shadikith the Glider"] = "滑翔者沙德基斯",
	["Shadow Hunter Vosh'gajin"] = "暗影猎手沃什加斯",
	["Shadow of Leotheras"] = "莱欧瑟拉斯之影",
	["Shadowpriest Sezz'ziz"] = "暗影祭司塞瑟斯",
	Shadron = "沙德隆",
	Shannox = "沙恩诺克斯",
	Shazzrah = "沙斯拉尔",
	["Shirrak the Dead Watcher"] = "死亡观察者希尔拉克",
	["Siamat, Lord of South Wind"] = "南风之主希亚玛特",
	Sindragosa = "辛达苟萨",
	Sinestra = "希奈丝特拉",
	["Sir Zeliek"] = "瑟里耶克爵士",
	["Sjonnir The Ironshaper"] = "塑铁者斯约尼尔",
	["Skadi the Ruthless"] = "残忍的斯卡迪",
	["Skarr the Unbreakable"] = "无敌的斯卡尔",
	["Skarvald the Constructor"] = "建筑师斯卡瓦尔德",
	["Skra'gath"] = "瑟克拉加斯",
	Skul = "斯库尔",
	Skum = "斯卡姆",
	Slabhide = "岩皮",
	["Slad'ran"] = "斯拉德兰",
	Sneed = "斯尼德",
	["Sneed's Shredder"] = "斯尼德的伐木机",
	["Solakar Flamewreath"] = "索拉卡·火冠",
	["Solarium Agent"] = "日晷密探",
	["Solarium Priest"] = "日晷祭司",
	["Spine of Deathwing"] = "死亡之翼的背脊",
	["Spirestone Battle Lord"] = "尖石统帅",
	["Spirestone Butcher"] = "尖石屠夫",
	["Spirestone Lord Magus"] = "尖石首席法师",
	["Staff of Disintegration"] = "瓦解法杖",
	Stalagg = "斯塔拉格",
	Steelbreaker = "断钢者",
	["Stomper Kreeg"] = "践踏者克雷格",
	Stonespine = "石脊",
	["Stormcaller Brundir"] = "唤雷者布隆迪尔",
	Strawman = "稻草人",
	["Sulfuron Harbinger"] = "萨弗隆先驱者",
	Supremus = "苏普雷姆斯",
	["Svala Sorrowgrave"] = "席瓦拉·索格蕾",
	["Swamplord Musel'ek"] = "沼地领主穆塞雷克",
	Taerar = "泰拉尔",
	["Tainted Spawn of Hydross"] = "污染的海度斯爪牙",
	["Talon King Ikiss"] = "利爪之王艾吉斯",
	["Taragaman the Hungerer"] = "饥饿者塔拉加曼",
	["Targorr the Dread"] = "可怕的塔格尔",
	Tavarok = "塔瓦洛克",
	Techbot = "尖端机器人",
	["Temple Guardian Anhuur"] = "神殿守护者安努尔",
	Temporus = "坦普卢斯",
	["Tendris Warpwood"] = "特迪斯·扭木",
	Tenebron = "塔尼布隆",
	["Terestian Illhoof"] = "特雷斯坦·邪蹄",
	["Teron Gorefiend"] = "塔隆·血魔",
	Terrastra = "泰拉斯卓",
	Thaddius = "塔迪乌斯",
	["Thaladred the Darkener"] = "亵渎者萨拉德雷",
	["Thane Korth'azz"] = "库尔塔兹领主",
	["The Beast"] = "比斯巨兽",
	["The Beasts of Northrend"] = "诺森德猛兽",
	["The Big Bad Wolf"] = "大灰狼",
	["The Black Knight"] = "黑骑士",
	["The Black Stalker"] = "黑色阔步者",
	["The Blue Brothers"] = "蓝色兄弟",
	["The Bug Family"] = "虫子一家",
	["The Crone"] = "巫婆",
	["The Curator"] = "馆长",
	["The Eredar Twins"] = "艾瑞达双子",
	["The Four Horsemen"] = "四骑士",
	["The Illidari Council"] = "伊利达雷议会",
	["The Iron Council"] = "钢铁议会",
	["The Lich King"] = "巫妖王",
	["The Lost Dwarves"] = "失踪的矮人",
	["The Lurker Below"] = "鱼斯拉",
	["The Maker"] = "制造者",
	["The Prophet Skeram"] = "预言者斯克拉姆",
	["The Prophet Tharon'ja"] = "先知萨隆亚",
	["The Ravenian"] = "拉文尼亚",
	["The Razza"] = "拉扎尔",
	["The Seven Dwarves"] = "七贤矮人",
	["The Skybreaker"] = "破天号",
	["The Tribunal of Ages"] = "远古法庭",
	["The Twin Emperors"] = "双子皇帝",
	["The Twin Val'kyr"] = "瓦格里双子",
	["The Unforgiven"] = "不可宽恕者",
	["The Windreaver"] = "烈风掠夺者",
	["Theka the Martyr"] = "殉教者塞卡",
	Theralion = "瑟纳利昂",
	Thorim = "托里姆",
	["Thorngrin the Tender"] = "看管者索恩格林",
	["Tidewalker Lurker"] = "踏潮潜伏者",
	["Timmy the Cruel"] = "悲惨的提米",
	Tinhead = "铁皮人",
	["Tinkerer Gizlock"] = "工匠吉兹洛克",
	["Tirion Fordring"] = "提里奧·弗丁",
	Tito = "托托",
	["Toravon the Ice Watcher"] = "寒冰看守者图拉旺",
	Toxitron = "剧毒金刚",
	["Trigore the Lasher"] = "鞭笞者特里高雷",
	Trollgore = "托尔戈",
	["Tsu'zee"] = "苏斯",
	["Tuten'kash"] = "图特卡什",
	["Twilight Lord Kelris"] = "梦游者克尔里斯",
	Ultraxion = "奥卓克希昂",
	["Urok Doomhowl"] = "乌洛克",
	["VX-001"] = "VX-001",
	["Vaelastrasz the Corrupt"] = "堕落的瓦拉斯塔兹",
	["Val'kyr Shadowguard"] = "瓦格里暗影戒卫者",
	Valiona = "瓦里昂娜",
	["Valiona and Theralion"] = "瓦里昂娜和瑟纳利昂",
	["Valithria Dreamwalker"] = "踏梦者瓦莉瑟瑞娅",
	["Vanessa VanCleef"] = "梵妮莎·范克里夫",
	["Varian Wrynn"] = "瓦里安·乌瑞恩",
	["Varos Cloudstrider"] = "瓦尔洛斯·云击",
	Vazruden = "瓦兹德",
	["Vazruden the Herald"] = "传令官瓦兹德",
	Vectus = "维克图斯",
	Vem = "维姆",
	Veng = "温格",
	["Veras Darkshadow"] = "维尔莱斯·深影",
	["Verdan the Everliving"] = "永生者沃尔丹",
	Verek = "维雷克",
	Vesperon = "维斯匹隆",
	Vexallus = "维萨鲁斯",
	["Veyzhak the Cannibal"] = "食尸者维萨克",
	["Vile'rel"] = "瓦勒雷尔",
	Viscidus = "维希度斯",
	["Viscous Fallout"] = "粘性辐射尘",
	["Void Reaver"] = "空灵机甲",
	Volkhan = "沃尔坎",
	["War Master Voone"] = "指挥官沃恩",
	["Warbringer O'mrogg"] = "战争使者沃姆罗格",
	["Warchief Blackhand Piece"] = "黑手酋长",
	["Warchief Kargath Bladefist"] = "酋长卡加斯·刃拳",
	["Warchief Rend Blackhand"] = "大酋长雷德·黑手",
	["Warden Mellichar"] = "监护者梅里卡尔",
	["Warder Stilgiss"] = "典狱官斯迪尔基斯",
	["Warlord Kalithresh"] = "督军卡利瑟里斯",
	["Warlord Zon'ozz"] = "督军佐诺兹",
	["Warmaster Blackhorn"] = "战争大师黑角",
	["Warmaul Champion"] = "战槌勇士",
	["Warp Slicer"] = "迁跃切割者",
	["Warp Splinter"] = "迁跃扭木",
	["Watchkeeper Gargolmar"] = "巡视者加戈玛",
	Weaver = "德拉维沃尔",
	["Willey Hopebreaker"] = "炮手威利",
	["Witch Doctor Zum'rah"] = "巫医祖穆拉恩",
	["Wolf Master Nandos"] = "狼王南杜斯",
	["Wrath-Scryer Soccothrates"] = "天怒预言者苏克拉底",
	Wushoolay = "乌苏雷",
	["XT-002 Deconstructor"] = "XT-002拆解者",
	Xevozz = "谢沃兹",
	["Yogg-Saron"] = "尤格-萨隆",
	Yor = "尤尔",
	["Yor'sahj the Unsleeping"] = "不眠的约萨希",
	Ysondre = "伊森德雷",
	Zanzil = "赞吉尔",
	Zekkis = "泽基斯",
	["Zelemar the Wrathful"] = "愤怒者塞雷玛尔",
	["Zereketh the Unbound"] = "自由的瑟雷凯斯",
	Zerillis = "泽雷利斯",
	["Zevrim Thornhoof"] = "瑟雷姆·刺蹄",
	Zolo = "祖罗",
	["Zul'Farrak Dead Hero"] = "祖尔法拉克阵亡英雄",
	["Zul'Lor"] = "祖罗尔",
	["Zul'jin"] = "祖尔金",
	["Zul'tore"] = "祖尔托",
	["Zuramat the Obliterator"] = "湮灭者祖拉玛特",
}
elseif GAME_LOCALE == "zhTW" then
	lib:SetCurrentTranslations {
	["\"Captain\" Cookie"] = "『隊長』餅乾",
	Acidmaw = "酸喉",
	["Admiral Ripsnarl"] = "利普斯納爾上將",
	Aeonus = "艾奧那斯",
	["Aerial Command Unit"] = "空中指揮裝置",
	["Agathelos the Raging"] = "暴怒的阿迦賽羅斯",
	["Aggem Thorncurse"] = "阿葛金·棘咒",
	Ahune = "艾胡恩",
	["Akil'zon"] = "阿奇爾森",
	["Aku'mai"] = "阿庫麥爾",
	["Al'Akir"] = "奧拉基爾",
	["Al'ar"] = "歐爾",
	["Algalon the Observer"] = "『觀察者』艾爾加隆",
	Altairus = "艾塔伊洛斯",
	Altarius = "艾塔伊洛斯",
	Alysrazor = "艾里絲拉卓",
	["Alzzin the Wildshaper"] = "『狂野變形者』奧茲恩",
	Amanitar = "毒蕈魔",
	["Ambassador Flamelash"] = "弗萊拉斯大使",
	["Ambassador Hellmaw"] = "海爾瑪大使",
	Ammunae = "安姆內",
	["Amnennar the Coldbringer"] = "『寒冰使者』亞門納爾",
	["Ancient Stone Keeper"] = "古代的石頭看守者",
	Anetheron = "安納塞隆",
	["Anger'rel"] = "安格雷爾",
	Anomalus = "艾諾瑪路斯",
	Anraphet = "安拉斐特",
	Anshal = "安蕭爾",
	["Antu'sul"] = "安圖蘇爾",
	["Anub'Rekhan"] = "阿努比瑞克漢",
	["Anub'arak"] = "阿努巴拉克",
	["Anub'shiah"] = "阿努希爾",
	["Anubisath Defender"] = "阿努比薩斯防衛者",
	["Anubisath Guardian"] = "阿努比薩斯守衛者",
	Anzu = "安祖",
	["Arcane Watchman"] = "秘法警備者",
	["Arcanist Doan"] = "秘法師杜安",
	Arcanotron = "秘法石像",
	Archaedas = "阿札達斯",
	["Archavon the Stone Watcher"] = "『石之看守者』亞夏梵",
	["Archbishop Benedictus"] = "大主教本尼迪塔斯",
	Archimonde = "阿克蒙德",
	["Archivist Galford"] = "檔案管理員加爾福特",
	["Archmage Arugal"] = "大法師阿魯高",
	Arcurion = "阿奇里森",
	Argaloth = "阿加羅斯",
	["Argent Confessor Paletress"] = "銀白告解者帕爾璀絲",
	Arion = "艾理奧",
	["Arugal's Voidwalker"] = "阿魯高的虛無行者",
	Asaad = "亞沙德",
	["Ascendant Council"] = "卓越者議會",
	["Ascendant Lord Obsidius"] = "卓越者統領奧希迪厄斯",
	["Asim al Akir"] = "亞沙德",
	["Asira Dawnslayer"] = "阿希拉黎明殺戮者",
	["Assault Bot"] = "突襲機器人",
	["Assembly of Iron"] = "鐵之集會",
	["Atal'alarion"] = "阿塔拉利恩",
	Atramedes = "亞特拉米德",
	["Attumen the Huntsman"] = "獵人阿圖曼",
	Auriaya = "奧芮雅",
	Avalanchion = "阿瓦蘭奇奧",
	["Avatar of Hakkar"] = "哈卡的化身",
	["Ayamiss the Hunter"] = "『狩獵者』阿亞米斯",
	Azgalor = "亞茲加洛",
	["Azshir the Sleepless"] = "不眠的艾希爾",
	Azuregos = "艾索雷葛斯",
	["Bael'Gar"] = "貝爾加",
	Baelog = "巴爾洛戈",
	Baleroc = "巴勒羅克",
	Balnazzar = "巴納札爾",
	["Baltharus the Warborn"] = "『戰爭之子』巴爾薩魯斯",
	["Bannok Grimaxe"] = "班諾克·巨斧",
	["Baron Aquanis"] = "阿奎尼斯男爵",
	["Baron Ashbury"] = "艾胥柏利男爵",
	["Baron Charr"] = "火焰男爵查爾",
	["Baron Geddon"] = "迦頓男爵",
	["Baron Kazum"] = "卡蘇姆男爵",
	["Baron Rivendare"] = "瑞文戴爾男爵",
	["Baron Silverlaine"] = "席瓦萊恩男爵",
	["Baroness Anastari"] = "安娜絲塔麗男爵夫人",
	["Battleguard Sartura"] = "沙爾圖拉",
	["Bazil Thredd"] = "巴基爾·斯瑞德",
	Bazzalan = "巴札蘭",
	Beauty = "美麗",
	["Beth'tilac"] = "貝絲堤拉克",
	["Black Guard Swordsmith"] = "黑衣守衛鑄劍師",
	["Blackheart the Inciter"] = "『煽動者』黑心",
	["Blind Hunter"] = "盲眼獵手",
	["Blindeye the Seer"] = "先知盲眼",
	["Blood Council"] = "血腥議會",
	["Blood Guard Porung"] = "血衛士波洛克",
	["Blood Prince Council"] = "血親王議會",
	["Blood Princes"] = "血親王",
	["Blood Steward of Kirtonos"] = "基爾圖諾斯的衛士",
	["Blood-Queen Lana'thel"] = "血腥女王菈娜薩爾",
	["Bloodlord Mandokir"] = "血領主曼多基爾",
	["Bloodmage Thalnos"] = "血法師薩爾諾斯",
	Boahn = "博艾恩",
	["Bomb Bot"] = "炸彈機器人",
	["Brain of Yogg-Saron"] = "尤格薩倫的腦部",
	["Brainwashed Noble"] = "被洗腦的貴族",
	Broggok = "布洛克",
	Brokentoe = "斷趾",
	Bronjahm = "布朗吉姆",
	["Broodlord Lashlayer"] = "龍領主勒西雷爾",
	["Bruegal Ironknuckle"] = "布魯戈·艾爾克納寇",
	Brutallus = "布魯托魯斯",
	["Burning Felguard"] = "燃燒惡魔守衛",
	["Buru the Gorger"] = "『暴食者』布魯",
	["C'Thun"] = "克蘇恩",
	["Cache of the Firelord"] = "火焰之王的寶箱",
	["Cache of the Legion"] = "軍團貯藏箱",
	["Cannon Master Willey"] = "砲手威利",
	["Captain Greenskin"] = "綠皮隊長",
	["Captain Kromcrush"] = "克羅卡斯",
	["Captain Skarloc"] = "史卡拉克上尉",
	["Captain Varo'then"] = "瓦羅森隊長",
	["Celebras the Cursed"] = "被詛咒的塞雷布拉斯",
	["Charlga Razorflank"] = "卡爾加·刺肋",
	["Chess Event"] = "西洋棋事件",
	["Chest of The Seven"] = "七賢之箱",
	["Chief Ukorz Sandscalp"] = "烏克茲·沙頂",
	Chimaeron = "奇瑪隆",
	["Cho'Rush the Observer"] = "『觀察者』克魯什",
	["Cho'gall"] = "丘加利",
	Chromaggus = "克洛瑪古斯",
	["Chrono Lord Deja"] = "時間領主迪賈",
	["Chrono-Lord Epoch"] = "紀元時間領主",
	Claw = "裂爪",
	["Coilfang Elite"] = "盤牙精英",
	["Coilfang Strider"] = "盤牙旅行者",
	["Commander Kolurg"] = "指揮官寇勒格",
	["Commander Malor"] = "指揮官瑪洛爾",
	["Commander Sarannis"] = "指揮官薩瑞尼斯",
	["Commander Springvale"] = "指揮官斯普林瓦爾",
	["Commander Stoutbeard"] = "指揮官厚鬚",
	["Commander Ulthok"] = "指揮官烏索克",
	["Conclave of Wind"] = "風之議會",
	["Constructor & Controller"] = "『建造者』與『控制者』",
	Cookie = "廚師",
	Corborus = "寇伯拉斯",
	["Coren Direbrew"] = "寇仁·恐酒",
	["Corla, Herald of Twilight"] = "柯爾菈，暮光信使",
	["Cosmic Infuser"] = "宇宙灌溉者",
	["Crimson Hammersmith"] = "紅衣鑄錘師",
	["Crowd Pummeler 9-60"] = "群體打擊者9-60",
	["Crystal Fang"] = "水晶之牙",
	Cyanigosa = "霞妮苟莎",
	Daakara = "達卡拉",
	["Dalliah the Doomsayer"] = "末日預言者達利亞",
	["Dalronn the Controller"] = "『控制者』達隆恩",
	["Dark Coffer"] = "黑暗寶箱",
	["Dark Iron Ambassador"] = "黑鐵大使",
	["Darkmaster Gandling"] = "黑暗院長加丁",
	["Darkweaver Syth"] = "暗法師希斯",
	["Death Knight Darkreaver"] = "死亡騎士達克雷爾",
	["Death Knight Understudy"] = "死亡騎士實習者",
	["Death Speaker Jargba"] = "亡語者賈格巴",
	["Deathbound Ward"] = "亡縛守衛",
	["Deathbringer Saurfang"] = "死亡使者薩魯法爾",
	["Deathspeaker High Priest"] = "亡頌者高階祭司",
	["Deathstalker Visceri"] = "亡靈哨兵威瑟瑞",
	["Deathsworn Captain"] = "死亡誓言者隊長",
	Devastation = "毀滅",
	["Deviate Faerie Dragon"] = "變異精靈龍",
	["Devourer of Souls"] = "眾魂吞噬者",
	["Dextren Ward"] = "迪克斯特·瓦德",
	["Digmaster Shovelphlange"] = "挖掘專家舒爾弗拉格",
	["Doctor Theolen Krastinov"] = "瑟爾林·卡斯迪諾夫教授",
	["Doom Lord Kazzak"] = "毀滅領主卡札克",
	["Doom'rel"] = "杜姆雷爾",
	Doomwalker = "厄運行者",
	["Dope'rel"] = "多普雷爾",
	Dorothee = "桃樂絲",
	["Drahga Shadowburner"] = "德拉卡·燃影者",
	["Drahga Shodowburner"] = "德拉卡·燃影者",
	["Drakkari Colossus"] = "德拉克瑞巨像",
	["Drakos the Interrogator"] = "『審問者』德拉高斯",
	Dreadscale = "懼鱗",
	Dreamscythe = "德姆塞卡爾",
	["Dust Covered Chest"] = "滿佈灰塵箱子",
	Dustwraith = "灰塵怨靈",
	["Eadric the Pure"] = "『純淨者』埃卓克",
	["Earthcaller Halmgar"] = "喚地者哈穆加",
	["Earthrager Ptah"] = "地怒者普塔",
	Ebonroc = "埃博諾克",
	["Echo of Baine"] = "貝恩的回音",
	["Echo of Jaina"] = "珍娜的回音",
	["Echo of Sylvanas"] = "希瓦娜斯的回音",
	["Echo of Tyrande"] = "泰蘭妲的回音",
	["Eck the Ferocious"] = "『兇猛』埃克",
	["Edwin VanCleef"] = "艾德溫·范克里夫",
	["Elder Brightleaf"] = "亮葉長者",
	["Elder Ironbranch"] = "鐵枝長者",
	["Elder Nadox"] = "老那杜斯",
	["Elder Stonebark"] = "石木長者",
	["Electrocutioner 6000"] = "電刑器6000型",
	Electron = "電石像",
	["Elementium Monstrosity"] = "卓越者議會",
	["Emalon the Storm Watcher"] = "『風暴看守者』艾瑪隆",
	Emeriss = "艾莫莉絲",
	["Emperor Dagran Thaurissan"] = "達格蘭·索瑞森大帝",
	["Emperor Vek'lor"] = "維克洛爾大帝",
	["Emperor Vek'nilash"] = "維克尼拉斯大帝",
	Entropius = "安卓普斯",
	["Eonar's Gift"] = "伊歐娜的贈禮",
	["Epoch Hunter"] = "紀元狩獵者",
	Erekem = "伊銳坎",
	["Eressea Dawnsinger"] = "艾瑞西雅·曦詠",
	["Eric \"The Swift\""] = "『迅捷』艾利克",
	Erudax = "伊魯達克斯",
	["Erunak Stonespeaker"] = "伊魯納克·石語者",
	["Essence of Anger"] = "憤怒精華",
	["Essence of Desire"] = "慾望精華",
	["Essence of Suffering"] = "受難精華",
	Eviscerator = "剜眼者",
	["Exarch Maladaar"] = "主教瑪拉達爾",
	["Expedition Commander"] = "遠征隊指揮官",
	["Eydis Darkbane"] = "艾狄絲·暗寂",
	["Eye of C'Thun"] = "克蘇恩之眼",
	["Faction Champions"] = "陣營勇士",
	["Fallen Champion"] = "亡靈勇士",
	Falric = "法勒瑞克",
	["Falric and Marwyn"] = "法勒瑞克和麥爾溫",
	["Fankriss the Unyielding"] = "不屈的范克里斯",
	["Fathom-Lord Karathress"] = "深淵之王卡拉薩瑞斯",
	Felmyst = "魔龍謎霧",
	Feludius = "費魯迪厄斯",
	["Fenrus the Devourer"] = "『吞噬者』芬魯斯",
	["Feral Defender"] = "野性防衛者",
	Festergut = "膿腸",
	Feugen = "伏晨",
	["Fineous Darkvire"] = "弗諾斯·達克維爾",
	Firemaw = "費爾默",
	["Fjola Lightbane"] = "菲歐拉·光寂",
	["Flame Leviathan"] = "烈焰戰輪",
	Flamegor = "弗萊格爾",
	["Foe Reaper 5000"] = "敵人收割者5000",
	["Foreman Thistlenettle"] = "工頭希斯耐特",
	["Forgemaster Garfrost"] = "鍛造大師加弗羅斯",
	["Forgemaster Throngus"] = "鍛造大師瑟隆葛斯",
	["Four Horsemen Chest"] = "四騎士箱子",
	["Fras Siabi"] = "弗拉斯·希亞比",
	Freya = "芙蕾雅",
	["Gahz'ranka"] = "加茲蘭卡",
	["Gahz'rilla"] = "加茲瑞拉",
	["Gal'darah"] = "蓋爾達拉",
	["Galgann Firehammer"] = "加加恩·火錘",
	Garr = "加爾",
	["Garrosh Hellscream"] = "卡爾洛斯·地獄吼",
	Gasher = "加什爾",
	["Gatewatcher Gyro-Kill"] = "看守者蓋洛奇歐",
	["Gatewatcher Iron-Hand"] = "看守者鐵手",
	["Gathios the Shatterer"] = "粉碎者高希歐",
	Gehennas = "基赫納斯",
	Gelihast = "格里哈斯特",
	Gelk = "吉爾克",
	["General Angerforge"] = "安格弗將軍",
	["General Bjarngrim"] = "畢亞格林將軍",
	["General Drakkisath"] = "達基薩斯將軍",
	["General Husam"] = "胡薩姆將軍",
	["General Rajaxx"] = "拉賈克斯將軍",
	["General Umbriss"] = "昂布里斯將軍",
	["General Vezax"] = "威札斯將軍",
	["General Zarithrian"] = "扎里斯利安將軍",
	["Ghamoo-ra"] = "加摩拉",
	["Ghaz'an"] = "高薩安",
	["Ghok Bashguud"] = "霍克·巴什古德",
	Gilnid = "基爾尼格",
	["Gizrul the Slavener"] = "『奴役者』基茲盧爾",
	["Gloom'rel"] = "格魯雷爾",
	Glubtok = "格魯巴托克",
	Gluth = "古魯斯",
	Glutton = "暴食者",
	["Golem Lord Argelmach"] = "魔像領主阿格曼奇",
	["Golemagg the Incinerator"] = "『焚化者』古雷曼格",
	["Goraluk Anvilcrack"] = "古拉魯克",
	["Gormok the Impaler"] = "「穿刺者」戈莫克",
	["Gorosh the Dervish"] = "『修行者』高羅什",
	["Gortok Palehoof"] = "戈托克·白蹄",
	["Gothik the Harvester"] = "『收割者』高希",
	["Grand Astromancer Capernian"] = "大星術師卡普尼恩",
	["Grand Champions"] = "大勇士",
	["Grand Crusader Dathrohan"] = "大十字軍戰士達索漢",
	["Grand Magus Telestra"] = "大魔導師特雷斯翠",
	["Grand Vizier Ertan"] = "首相伊爾丹",
	["Grand Warlock Alythess"] = "大術士艾黎瑟絲",
	["Grand Warlock Nethekurse"] = "大術士奈德克斯",
	["Grand Widow Faerlina"] = "大寡婦費琳娜",
	["Grandmaster Vorpil"] = "宗師瓦皮歐",
	Grandmother = "外婆",
	["Grethok the Controller"] = "『控制者』葛瑞托克",
	["Gri'lek"] = "格里雷克",
	Grimlok = "格瑞姆洛克",
	Grizzle = "格里茲爾",
	Grobbulus = "葛羅巴斯",
	Grubbis = "格魯比斯",
	["Gruul the Dragonkiller"] = "弒龍者戈魯爾",
	["Guard Fengus"] = "衛兵芬古斯",
	["Guard Mol'dar"] = "衛兵摩爾達",
	["Guard Slip'kik"] = "衛兵斯里基克",
	["Guardian of Yogg-Saron"] = "尤格薩倫守護者",
	["Gurtogg Bloodboil"] = "葛塔格·血沸",
	Gyth = "蓋斯",
	Hadronox = "哈卓諾克斯",
	["Hagara the Stormbinder"] = "『暴風守縛者』哈甲拉",
	Hakkar = "哈卡",
	Halazzi = "哈拉齊",
	["Halfus Wyrmbreaker"] = "哈福斯•破龍者",
	Halion = "海萊恩",
	Halycon = "哈雷肯",
	Hamhock = "哈姆霍克",
	["Harbinger Skyriss"] = "先驅者史蓋力司",
	["Hate'rel"] = "黑特雷爾",
	["Hazza'rah"] = "哈札拉爾",
	Hazzas = "哈札斯",
	["Headless Horseman"] = "無頭騎士",
	["Hearthsinger Forresten"] = "弗雷斯特恩",
	["Hedrum the Creeper"] = "『蠕行者』赫杜姆 ",
	["Heigan the Unclean"] = "『不潔者』海根",
	["Helix Gearbreaker"] = "赫利克斯•碎輪者",
	["Hellfire Channeler"] = "地獄火導魔師",
	["Henry Stern"] = "亨利·斯特恩",
	["Herald Volazj"] = "信使沃菈齊",
	Herod = "赫洛德",
	["Hex Lord Malacrass"] = "妖術領主瑪拉克雷斯",
	["High Astromancer Solarian"] = "高階星術師索拉瑞恩",
	["High Botanist Freywinn"] = "大植物學家費瑞衛恩",
	["High Inquisitor Fairbanks"] = "高等審判官法爾班克斯",
	["High Inquisitor Whitemane"] = "高等審判官懷特邁恩",
	["High Interrogator Gerstahn"] = "審訊官格斯塔恩",
	["High King Maulgar"] = "大君王莫卡爾",
	["High Marshal Whirlaxis"] = "大元帥維拉希斯",
	["High Nethermancer Zerevor"] = "高等虛空術師札瑞佛",
	["High Overlord Saurfang"] = "薩魯法爾霸王",
	["High Priest Thekal"] = "高階祭司塞卡爾",
	["High Priest Venoxis"] = "高階祭司溫諾希斯",
	["High Priestess Arlokk"] = "哈卡萊先知",
	["High Priestess Azil"] = "高階祭司艾吉兒",
	["High Priestess Jeklik"] = "高階祭司耶克里克",
	["High Priestess Kilnara"] = "高階祭司基爾娜拉",
	["High Priestess Mar'li"] = "哈卡萊安魂者",
	["High Priestess of Thaurissan"] = "索瑞森高階女祭司",
	["High Prophet Barim"] = "高階預言者巴瑞姆",
	["High Warlord Naj'entus"] = "高階督軍納珍塔斯",
	["Highlord Mograine"] = "大領主莫格萊尼",
	["Highlord Omokk"] = "歐莫克大王",
	Hodir = "霍迪爾",
	Hogger = "霍格",
	["Houndmaster Grebmar"] = "馴犬者格雷布瑪爾",
	["Houndmaster Loksey"] = "馴犬者洛克希",
	Hukku = "胡庫",
	Hungarfen = "飢餓之牙",
	["Hurley Blackbreath"] = "霍爾雷·黑鬚",
	["Hyakiss the Lurker"] = "潛伏者亞奇斯",
	["Hydromancer Thespia"] = "海法師希斯比亞",
	["Hydromancer Velratha"] = "水占師維蕾薩",
	Hydrospawn = "海多斯博恩",
	["Hydross the Unstable"] = "不穩定者海卓司",
	["Ice Sphere"] = "寒冰球體",
	["Icecrown Gunship Battle"] = "寒冰皇冠空中艦艇戰",
	Icehowl = "冰嚎",
	Ichoron = "伊仇隆",
	Ick = "艾克",
	Ignacious = "伊格納修斯",
	["Ignis the Furnace Master"] = "『火爐之主』伊格尼司",
	["Illidan Stormrage"] = "伊利丹·怒風",
	["Illidari Council"] = "伊利達瑞議會",
	["Illyanna Ravenoak"] = "伊琳娜·鴉橡",
	["Immol'thar"] = "伊莫塔爾",
	["Infinite Corruptor"] = "恆龍墮落者",
	["Infinity Blades"] = "無盡之刃",
	["Ingvar the Plunderer"] = "『盜掠者』因格瓦",
	["Instructor Galford"] = "檔案管理員加爾福特",
	["Instructor Malicia"] = "講師瑪麗希亞",
	["Instructor Razuvious"] = "講師拉祖維斯",
	["Interrogator Vishas"] = "審訊員韋沙斯",
	Ionar = "埃歐納",
	Ironaya = "艾隆納亞",
	Ironspine = "鐵脊死靈",
	Isalien = "依薩利恩",
	Isiset = "伊希賽特",
	Jade = "玉龍",
	["Jammal'an the Prophet"] = "『預言者』迦瑪蘭",
	["Jan'alai"] = "賈納雷",
	["Jandice Barov"] = "詹迪斯·巴羅夫",
	["Jed Runewatcher"] = "傑德",
	["Jedoga Shadowseeker"] = "潔杜佳·尋影者",
	["Jergosh the Invoker"] = "『塑能師』耶戈什",
	["Jin'do the Godbreaker"] = "破神者金度",
	["Jin'do the Hexxer"] = "『妖術師』金度",
	["Jormungar Behemoth"] = "蟄猛巨獸",
	Jormungars = "巨蟲",
	Julianne = "茱麗葉",
	["Junk Bot"] = "垃圾機器人",
	["Kael'thas Sunstrider"] = "凱爾薩斯·逐日者",
	Kalecgos = "卡雷苟斯",
	["Kam Deepfury"] = "卡姆·深怒",
	["Karsh Steelbender"] = "卡爾許·控鋼者",
	["Kaz'rogal"] = "卡茲洛加",
	["Kazkaz the Unholy"] = "邪惡的卡薩卡茲",
	["Kel'Thuzad"] = "科爾蘇加德",
	["Keli'dan the Breaker"] = "『破壞者』凱利丹",
	Keristrasza = "凱瑞史卓莎",
	["Kiggler the Crazed"] = "瘋癲者奇克勒",
	["Kil'jaeden"] = "基爾加丹",
	["Kil'rek"] = "基瑞克",
	["King Dred"] = "崔德王",
	["King Gordok"] = "戈多克大王",
	["King Llane Piece"] = "萊恩王棋子",
	["King Ymiron"] = "依米倫王",
	["Kirtonos the Herald"] = "傳令官基爾圖諾斯",
	["Knot Thimblejack's Cache"] = "諾特·希姆加克的儲物箱",
	Kolk = "考爾克",
	Kologarn = "柯洛剛恩",
	["Koralon the Flame Watcher"] = "『烈焰看守者』寇拉隆",
	Kormok = "科爾莫克",
	Kresh = "克雷什",
	Krick = "克瑞克",
	["Krick and Ick"] = "艾克與克瑞克",
	["Krik'thir the Gatewatcher"] = "『守門者』齊力克西爾",
	["Krosh Firehand"] = "克羅斯·火手",
	Krystallus = "克利斯托魯斯",
	Kurinnaxx = "庫林納克斯",
	["Lady Anacondra"] = "安娜科德拉",
	["Lady Blaumeux"] = "布洛莫斯女士",
	["Lady Deathwhisper"] = "亡語女士",
	["Lady Illucia Barov"] = "伊露希亞·巴羅夫女士",
	["Lady Malande"] = "瑪蘭黛女士",
	["Lady Naz'jar"] = "納茲賈爾女士",
	["Lady Sacrolash"] = "莎珂蕾希女士",
	["Lady Sarevess"] = "薩利維絲女士",
	["Lady Vashj"] = "瓦許女士",
	Laj = "拉杰",
	Landslide = "蘭斯利德",
	Lavanthor = "拉方索",
	["Left Arm"] = "左臂",
	["Leotheras the Blind"] = "『盲目者』李奧薩拉斯",
	Lethon = "雷索",
	Lethtendris = "蕾瑟塔蒂絲",
	["Leviathan Mk II"] = "戰輪MK II",
	["Ley-Guardian Eregos"] = "地脈守護者伊瑞茍斯",
	["Lieutenant Drake"] = "中尉崔克",
	["Lieutenant General Andorov"] = "安多洛夫中將",
	Loatheb = "憎恨者",
	Lockmaw = "鎖喉",
	Loken = "洛肯",
	["Lord Alexei Barov"] = "阿萊克斯·巴羅夫領主",
	["Lord Aurius Rivendare"] = "奧里爾斯·瑞文戴爾領主",
	["Lord Cobrahn"] = "考布萊恩領主",
	["Lord Godfrey"] = "高佛雷領主",
	["Lord Hel'nurath"] = "赫爾努拉斯領主",
	["Lord Incendius"] = "伊森迪奧斯領主",
	["Lord Jaraxxus"] = "賈拉克瑟斯領主",
	["Lord Kazzak"] = "毀滅領主卡札克",
	["Lord Kri"] = "克里領主",
	["Lord Marrowgar"] = "瑪洛嘉領主",
	["Lord Overheat"] = "歐玻西特王",
	["Lord Pythas"] = "皮薩斯領主",
	["Lord Rhyolith"] = "萊爾利斯領主",
	["Lord Roccor"] = "洛考爾領主",
	["Lord Sanguinar"] = "桑古納爾領主",
	["Lord Serpentis"] = "瑟芬迪斯領主",
	["Lord Skwol"] = "斯古恩領主",
	["Lord Valthalak"] = "瓦薩拉克領主",
	["Lord Victor Nefarius"] = "維克多·奈法利斯領主",
	["Lord Vyletongue"] = "維利塔恩領主",
	["Lord Walden"] = "瓦爾登領主",
	["Lorekeeper Polkelt"] = "博學者普克爾特",
	["Lorgus Jett"] = "洛古斯·傑特",
	Loro = "洛若爾",
	Lucifron = "魯西弗隆",
	["M'uru"] = "莫魯",
	["Mad Magglish"] = "瘋狂的馬格利什",
	["Madness of Deathwing"] = "死亡之翼的狂亂",
	Maexxna = "梅克絲娜",
	["Mage-Lord Urom"] = "法師領主厄隆",
	["Magister Kalendris"] = "卡雷迪斯鎮長",
	["Magistrate Barthilas"] = "巴瑟拉斯鎮長",
	Magmadar = "瑪格曼達",
	Magmatron = "火石像",
	Magmaw = "熔喉",
	Magmus = "瑪格姆斯",
	Magra = "瑪格拉",
	Magtheridon = "瑪瑟里頓",
	["Maiden of Grief"] = "悲嘆少女",
	["Maiden of Virtue"] = "貞潔聖女",
	["Majordomo Executus"] = "管理者埃克索圖斯",
	["Majordomo Staghelm"] = "管理者鹿盔",
	["Mal'Ganis"] = "瑪爾加尼斯",
	Malacrass = "瑪拉克雷斯",
	["Maleki the Pallid"] = "蒼白的瑪勒基",
	Maloriak = "瑪洛里亞克",
	Malygos = "瑪里苟斯",
	Mannoroth = "瑪諾洛斯",
	Maraudos = "瑪拉多斯",
	["Marduk Blackpool"] = "馬杜克·布萊克波爾",
	["Marisa du'Paige"] = "瑪里莎·杜派格",
	Marwyn = "麥爾溫",
	["Master Engineer Telonicus"] = "工程大師泰隆尼卡斯",
	["Maur Grimtotem"] = "瑪爾·恐怖圖騰",
	Meathook = "肉鉤",
	["Mechano-Lord Capacitus"] = "機械王卡帕希特斯",
	Medivh = "麥迪文",
	["Mekgineer Steamrigger"] = "米克吉勒·蒸氣操控者",
	["Mekgineer Thermaplugg"] = "麥克尼爾·瑟瑪普拉格",
	["Mennu the Betrayer"] = "背叛者曼紐",
	["Meshlok the Harvester"] = "『收割者』麥什洛克",
	Midnight = "午夜",
	Mijan = "米杉",
	Mimiron = "彌米倫",
	["Mindbender Ghur'sha"] = "屈心者哥爾薩",
	["Miner Johnson"] = "礦工約翰森",
	["Mistress of Pain"] = "痛苦仕女",
	Moam = "莫阿姆",
	Mogor = "莫古",
	["Mokra the Skullcrusher"] = "『碎顱者』莫克拉",
	Moorabi = "慕拉比",
	["Mor Grayhoof"] = "莫爾·灰蹄",
	Moragg = "摩拉革",
	Morchok = "魔寇",
	["Mordresh Fire Eye"] = "火眼莫德雷斯",
	Moroes = "摩洛",
	["Morogrim Tidewalker"] = "莫洛葛利姆·潮行者",
	Morphaz = "摩弗拉斯",
	["Mother Shahraz"] = "薩拉茲女士",
	["Mother Smolderweb"] = "煙網蛛后",
	["Mr. Smite"] = "重拳先生",
	["Muradin Bronzebeard"] = "穆拉丁·銅鬚",
	["Murkblood Twin"] = "黑暗之血雙子",
	["Murkblood Twins"] = "黑暗之血雙子",
	Murmur = "莫爾墨",
	Murozond = "姆多茲諾",
	["Murta Grimgut"] = "莫爾塔",
	Mushgog = "姆斯高格",
	["Mutanus the Devourer"] = "『吞噬者』穆坦努斯",
	Nalorakk = "納羅拉克",
	Nazan = "納桑",
	Nefarian = "奈法利安",
	["Nefarian's End"] = "奈法利安之末日",
	["Nekrum Gutchewer"] = "耐克魯姆",
	["Nerub'enkan"] = "奈幽布恩坎",
	["Nethermancer Sepethrea"] = "虛空術師賽菲瑞雅",
	Netherspite = "尼德斯",
	["Netherstrand Longbow"] = "虛空之絃長弓",
	["Nexus-Prince Shaffar"] = "奈薩斯王子薩法爾",
	Nezir = "涅茲爾",
	Nightbane = "夜禍",
	["Noth the Plaguebringer"] = "『瘟疫使者』諾斯",
	["Novos the Summoner"] = "『召喚者』諾沃司",
	Noxxion = "諾克賽恩",
	["Obsidian Sentinel"] = "黑曜石哨兵",
	["Occu'thar"] = "歐庫薩",
	["Odo the Blindwatcher"] = "『盲眼守衛』奧杜",
	Oggleflint = "奧格弗林特",
	["Ogom the Wretched"] = "可悲的奧戈姆",
	Ohgan = "奧根",
	["Ok'thor the Breaker"] = "『破壞者』奧科索爾",
	Olaf = "奧拉夫",
	["Old Serra'kis"] = "老瑟拉吉斯",
	["Olm the Summoner"] = "召喚者歐莫",
	["Omnitron Defense System"] = "全能魔像防禦系統",
	Omnotron = "全能魔像",
	["Omnotron Defense System"] = "全能魔像防禦系統",
	["Omor the Unscarred"] = "『無疤者』歐瑪爾",
	Onyxia = "奧妮克希亞",
	["Opera Event"] = "歌劇院",
	["Orgrim's Hammer"] = "奧格林之錘",
	["Ormorok the Tree-Shaper"] = "『樹木造形者』歐爾莫洛克",
	["Oro Eyegouge"] = "歐魯·鑿眼",
	["Ossirian the Unscarred"] = "『無疤者』奧斯里安",
	Ouro = "奧羅",
	["Overlord Ramtusk"] = "拉姆塔斯主宰",
	["Overlord Wyrmthalak"] = "維姆薩拉克主宰",
	["Overmaster Pyron"] = "征服者派隆",
	["Overseer Tidewrath"] = "監督者泰洛斯",
	Ozruk = "歐茲魯克",
	Ozumat = "歐蘇瑪特",
	Pandemonius = "班提蒙尼厄斯",
	["Panzor the Invincible"] = "無敵的潘佐爾",
	Patchwerk = "縫補者",
	["Pathaleon the Calculator"] = "操縱者帕薩里歐",
	["Peroth'arn"] = "佩洛薩恩",
	Phalanx = "法拉克斯",
	["Phaseshift Bulwark"] = "相位壁壘",
	Pimgib = "匹姆吉布",
	["Plaguemaw the Rotting"] = "腐爛的普雷莫爾",
	["Plugger Spazzring"] = "普拉格·史帕齊林",
	["Postmaster Malown"] = "郵差瑪羅恩",
	["Priestess Delrissa"] = "女牧師戴利莎",
	["Prince Keleseth"] = "凱雷希斯親王",
	["Prince Malchezaar"] = "莫克札王子",
	["Prince Skaldrenox"] = "斯卡德諾克斯王子",
	["Prince Taldaram"] = "泰爾達朗親王",
	["Prince Tenris Mirkblood"] = "坦瑞斯·暗血王子",
	["Prince Tortheldrin"] = "托塞德林王子",
	["Prince Valanar"] = "瓦拉納爾親王",
	["Princess Huhuran"] = "哈霍蘭公主",
	["Princess Moira Bronzebeard"] = "茉艾拉·銅鬚公主",
	["Princess Tempestria"] = "泰比斯蒂亞公主",
	["Princess Theradras"] = "瑟萊德絲公主",
	["Princess Yauj"] = "亞爾基公主",
	["Professor Putricide"] = "普崔希德教授",
	["Pure Spawn of Hydross"] = "純正的海卓司子嗣",
	Pusillin = "普希林",
	["Pyroguard Emberseer"] = "烈焰衛士艾博希爾",
	["Pyromancer Loregrain"] = "火占師羅格雷恩",
	Quagmirran = "奎克米瑞",
	["Quartermaster Zigris"] = "軍需官茲格雷斯",
	["Queen Azshara"] = "艾薩拉女王",
	["Rage Winterchill"] = "瑞齊·凜冬",
	Ragglesnout = "拉戈斯諾特",
	["Raging Spirit"] = "狂怒的鬼魂",
	Ragnaros = "拉格納羅斯",
	Rajh = "拉頡",
	["Ramstein the Gorger"] = "『暴食者』拉姆斯登",
	["Randolph Moloch"] = "藍道夫·摩洛克",
	["Ras Frostwhisper"] = "萊斯·霜語",
	Rattlegore = "血骨傀儡",
	["Razorclaw the Butcher"] = "屠夫拉佐克勞",
	["Razorgore the Untamed"] = "狂野的拉佐格爾",
	Razorlash = "銳刺鞭笞者",
	Razorscale = "銳鱗",
	["Reliquary of Souls"] = "靈魂之匣",
	Renataki = "雷納塔基",
	["Restless Skeleton"] = "永不安息的骷髏",
	Rethilgore = "雷希戈爾",
	Revelosh = "魯維羅什",
	["Rhahk'Zor"] = "拉克佐",
	["Ribbly Screwspigot"] = "雷布里·斯庫比格特",
	["Right Arm"] = "右臂",
	["Ring of Law"] = "秩序競技場",
	["Risen Hammersmith"] = "紅衣錘類鍛造師",
	Roar = "獅子",
	Rohash = "洛哈許",
	["Rokad the Ravager"] = "劫毀者拉卡",
	["Rokdar the Sundered Lord"] = "『碎裂領主』洛克達",
	["Rokmar the Crackler"] = "爆裂者洛克瑪",
	["Rom'ogg Bonecrusher"] = "羅姆歐格·裂骨者",
	Romulo = "羅慕歐",
	["Romulo & Julianne"] = "羅慕歐與茱麗葉",
	Roogug = "魯古格",
	Rotface = "腐臉",
	Rotgrip = "洛特格里普",
	["Runemaster Molgeim"] = "符文大師墨吉姆",
	["Runok Wildmane"] = "魯諾克·蠻鬃",
	Ruuzlu = "盧茲魯",
	["Salramm the Fleshcrafter"] = "『血肉工匠』塞歐朗姆",
	["Sanctum Sentry"] = "聖所哨兵",
	["Sandarr Dunereaver"] = "杉達爾·沙掠者",
	["Sandfury Executioner"] = "沙怒劊子手",
	Sapphiron = "薩菲隆",
	Sara = "薩拉",
	["Saronite Animus"] = "薩倫聚惡體",
	Sartharion = "撒爾薩里安",
	["Sathrovarr the Corruptor"] = "『墮落者』塞斯諾瓦",
	["Saviana Ragefire"] = "薩薇安娜‧怒焰",
	["Scarlet Commander Mograine"] = "血色十字軍指揮官莫格萊尼",
	["Scourgelord Tyrannus"] = "天譴領主提朗紐斯",
	["Seeth'rel"] = "西斯雷爾",
	["Selin Fireheart"] = "賽林·炎心",
	["Sergeant Bly"] = "布萊中士",
	Setesh = "賽特胥",
	["Shade of Akama"] = "阿卡瑪的黑暗面",
	["Shade of Aran"] = "埃蘭之影",
	["Shade of Eranikus"] = "伊蘭尼庫斯之影",
	["Shadikith the Glider"] = "滑翔者薛迪依斯",
	["Shadow Hunter Vosh'gajin"] = "暗影獵手沃許加斯",
	["Shadow of Leotheras"] = "李奧薩拉斯的陰影",
	["Shadowpriest Sezz'ziz"] = "暗影祭司塞瑟斯",
	Shadron = "夏德朗",
	Shannox = "夏諾克斯",
	Shazzrah = "沙斯拉爾",
	["Shirrak the Dead Watcher"] = "死亡看守者辛瑞克",
	["Siamat, Lord of South Wind"] = "希亞梅特，南風領主",
	Sindragosa = "辛德拉苟莎",
	Sinestra = "賽絲特拉",
	["Sir Zeliek"] = "札里克爵士",
	["Sjonnir The Ironshaper"] = "『塑鐵者』斯雍尼爾",
	["Skadi the Ruthless"] = "無情的斯卡迪",
	["Skarr the Unbreakable"] = "無敵的斯卡爾",
	["Skarvald the Constructor"] = "『建造者』史卡沃",
	["Skra'gath"] = "史卡拉克斯",
	Skul = "斯庫爾",
	Skum = "斯卡姆",
	Slabhide = "岩革",
	["Slad'ran"] = "史拉德銳",
	Sneed = "斯尼德",
	["Sneed's Shredder"] = "斯尼德的伐木機",
	["Solakar Flamewreath"] = "索拉卡·火冠",
	["Solarium Agent"] = "日光之室密探",
	["Solarium Priest"] = "日光之室牧師",
	["Spine of Deathwing"] = "死亡之翼的脊椎",
	["Spirestone Battle Lord"] = "尖石戰鬥統帥",
	["Spirestone Butcher"] = "尖石屠夫",
	["Spirestone Lord Magus"] = "尖石首席魔導師",
	["Staff of Disintegration"] = "瓦解之杖",
	Stalagg = "斯塔拉格",
	Steelbreaker = "破鋼者",
	["Stomper Kreeg"] = "踐踏者克雷格",
	Stonespine = "石脊",
	["Stormcaller Brundir"] = "風暴召喚者布倫迪爾",
	Strawman = "稻草人",
	["Sulfuron Harbinger"] = "薩弗隆先驅者",
	Supremus = "瑟普莫斯",
	["Svala Sorrowgrave"] = "絲瓦拉·悲傷亡墓",
	["Swamplord Musel'ek"] = "沼澤之王莫斯萊克",
	Taerar = "泰拉爾",
	["Tainted Spawn of Hydross"] = "腐化的海卓司之子",
	["Talon King Ikiss"] = "鷹王伊奇斯",
	["Taragaman the Hungerer"] = "『飢餓者』塔拉加曼",
	["Targorr the Dread"] = "可怕的塔高爾",
	Tavarok = "塔瓦洛克",
	Techbot = "尖端機器人",
	["Temple Guardian Anhuur"] = "神殿守護者安胡爾",
	Temporus = "坦普拉斯",
	["Tendris Warpwood"] = "特迪斯·扭木",
	Tenebron = "坦納伯朗",
	["Terestian Illhoof"] = "泰瑞斯提安·疫蹄",
	["Teron Gorefiend"] = "泰朗·血魔",
	Terrastra = "特拉斯特拉",
	Thaddius = "泰迪斯",
	["Thaladred the Darkener"] = "扭曲預言家薩拉瑞德",
	["Thane Korth'azz"] = "寇斯艾茲族長",
	["The Beast"] = "比斯巨獸",
	["The Beasts of Northrend"] = "北裂境巨獸",
	["The Big Bad Wolf"] = "大野狼",
	["The Black Knight"] = "黑騎士",
	["The Black Stalker"] = "黑色捕獵者",
	["The Blue Brothers"] = "憂鬱兄弟黨",
	["The Bug Family"] = "蟲子家族",
	["The Crone"] = "老巫婆",
	["The Curator"] = "館長",
	["The Eredar Twins"] = "埃雷達爾雙子",
	["The Four Horsemen"] = "四騎士",
	["The Illidari Council"] = "伊利達瑞議事",
	["The Iron Council"] = "鐵之集會",
	["The Lich King"] = "巫妖王",
	["The Lost Dwarves"] = "失蹤的矮人",
	["The Lurker Below"] = "海底潛伏者",
	["The Maker"] = "創造者",
	["The Prophet Skeram"] = "預言者斯克拉姆",
	["The Prophet Tharon'ja"] = "預言者薩隆杰",
	["The Ravenian"] = "拉文尼亞",
	["The Razza"] = "拉札",
	["The Seven Dwarves"] = "七賢人",
	["The Skybreaker"] = "破天者號",
	["The Tribunal of Ages"] = "歲月議庭",
	["The Twin Emperors"] = "雙子皇帝",
	["The Twin Val'kyr"] = "華爾琪雙子",
	["The Unforgiven"] = "不可寬恕者",
	["The Windreaver"] = "烈風搶奪者",
	["Theka the Martyr"] = "『殉教者』塞卡",
	Theralion = "瑟拉里恩",
	Thorim = "索林姆",
	["Thorngrin the Tender"] = "『看管者』索古林",
	["Tidewalker Lurker"] = "潮行者潛伏者",
	["Timmy the Cruel"] = "悲慘的提米",
	Tinhead = "機器人",
	["Tinkerer Gizlock"] = "技工吉茲洛克",
	["Tirion Fordring"] = "提里奧·弗丁",
	Tito = "多多",
	["Toravon the Ice Watcher"] = "『寒冰看守者』拓拉梵",
	Toxitron = "毒石像",
	["Trigore the Lasher"] = "『鞭笞者』特里高雷",
	Trollgore = "血角食人妖",
	["Tsu'zee"] = "蘇斯",
	["Tuten'kash"] = "圖特卡什",
	["Twilight Lord Kelris"] = "暮光領主克爾里斯",
	Ultraxion = "奧特拉賽恩",
	["Urok Doomhowl"] = "烏洛克",
	["VX-001"] = "VX-001",
	["Vaelastrasz the Corrupt"] = "墮落的瓦拉斯塔茲",
	["Val'kyr Shadowguard"] = "華爾琪影衛",
	Valiona = "瓦莉歐娜",
	["Valiona and Theralion"] = "瓦莉歐娜和瑟拉里恩",
	["Valithria Dreamwalker"] = "瓦莉絲瑞雅·夢行者",
	["Vanessa VanCleef"] = "凡妮莎·范克里夫",
	["Varian Wrynn"] = "瓦里安·烏瑞恩",
	["Varos Cloudstrider"] = "瓦羅斯·雲行者",
	Vazruden = "維斯路登",
	["Vazruden the Herald"] = "『信使』維斯路登",
	Vectus = "維克圖斯",
	Vem = "維姆",
	Veng = "溫格",
	["Veras Darkshadow"] = "維拉斯·深影",
	["Verdan the Everliving"] = "永生的沃爾丹",
	Verek = "維雷克",
	Vesperon = "維斯佩朗",
	Vexallus = "維克索魯斯",
	["Veyzhak the Cannibal"] = "『食人者』維薩克",
	["Vile'rel"] = "瓦勒雷爾",
	Viscidus = "維希度斯",
	["Viscous Fallout"] = "粘性輻射塵",
	["Void Reaver"] = "虛無搶奪者",
	Volkhan = "渥克瀚",
	["War Master Voone"] = "將領沃恩",
	["Warbringer O'mrogg"] = "戰爭使者歐姆拉格",
	["Warchief Blackhand Piece"] = "黑手大酋長棋子",
	["Warchief Kargath Bladefist"] = "大酋長卡加斯·刃拳",
	["Warchief Rend Blackhand"] = "大酋長雷德·黑手",
	["Warden Mellichar"] = "看守者米利恰爾",
	["Warder Stilgiss"] = "護衛斯迪爾基斯",
	["Warlord Kalithresh"] = "督軍卡利斯瑞",
	["Warlord Zon'ozz"] = "督軍松奧茲",
	["Warmaster Blackhorn"] = "將領黑角",
	["Warmaul Champion"] = "戰槌勇士",
	["Warp Slicer"] = "扭曲分割者",
	["Warp Splinter"] = "扭曲分裂者",
	["Watchkeeper Gargolmar"] = "看護者卡爾古瑪",
	Weaver = "德拉維沃爾",
	["Willey Hopebreaker"] = "威利•希望破除者",
	["Witch Doctor Zum'rah"] = "巫醫·祖穆拉恩",
	["Wolf Master Nandos"] = "狼王南杜斯",
	["Wrath-Scryer Soccothrates"] = "怒鐮者索寇斯瑞特",
	Wushoolay = "烏蘇雷",
	["XT-002 Deconstructor"] = "XT-002拆解者",
	Xevozz = "基沃滋",
	["Yogg-Saron"] = "尤格薩倫",
	Yor = "約兒",
	["Yor'sahj the Unsleeping"] = "未眠者尤沙吉",
	Ysondre = "伊索德雷",
	Zanzil = "贊吉爾",
	Zekkis = "澤基斯",
	["Zelemar the Wrathful"] = "憤怒的賽勒瑪爾",
	["Zereketh the Unbound"] = "無約束的希瑞奇斯",
	Zerillis = "澤雷利斯",
	["Zevrim Thornhoof"] = "瑟雷姆·刺蹄",
	Zolo = "祖羅",
	["Zul'Farrak Dead Hero"] = "祖爾法拉克陣亡英雄",
	["Zul'Lor"] = "祖羅爾",
	["Zul'jin"] = "祖爾金",
	["Zul'tore"] = "祖爾拓",
	["Zuramat the Obliterator"] = "『消滅者』舒拉邁特",
}

else
	error(("%s: Locale %q not supported"):format(MAJOR_VERSION, GAME_LOCALE))
end
